<?php
/**
 * Webkul Software.
 *
 * @category  Webkul
 * @package   Webkul_Mobikul
 * @author    Webkul
 * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\Mobikul\Controller\AccountVerify;

use Magento\Store\Model\App\Emulation;
use Magento\Framework\App\Action\Context;
use Webkul\Mobikul\Helper\Data as HelperData;

abstract class AbstractAccount extends \Webkul\Mobikul\Controller\ApiController    {

    protected $_emulate;

    public function __construct(
        Context $context,
        Emulation $emulate,
        HelperData $helper,
        \Natz\AccountVerify\Model\VerificationProcess $verProcess,
        \Magento\Checkout\Model\Cart $cartData,
        \Magento\Customer\Model\Session $session
    ) {
        $this->_emulate = $emulate;
        $this->_verProcess = $verProcess;
        $this->cart = $cartData;
        $this->_customerSession = $session;
        parent::__construct($helper, $context);
    }
}