<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\AccountVerify;

    class SendVerify extends AbstractAccount    {

        public function execute()   {
            $returnArray                 = [];
            $returnArray["success"]      = false;
            try {
                $wholeData      = $this->getRequest()->getPostValue();
                $this->_headers = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey  = $this->getRequest()->getHeader("authKey");
                    $authData = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $storeId     = $wholeData["storeId"]      ?? 1;
                        $mobileNo    = $wholeData["mobileNumber"] ?? '';
                        $email       = $wholeData["email"]        ?? '';
                        $countryCode = $wholeData["co"]           ?? '';
                        $lastName    = $wholeData["lastName"]     ?? '';
                        $firstName   = $wholeData["firstName"]    ?? '';
                        $status      = $wholeData["status"]       ?? 0;

                        $environment = $this->_emulate->startEnvironmentEmulation($storeId);
                        $data = [
                            'firstname'     => $firstName,
                            'lastname'      => $lastName,
                            'mobile_number' => $mobileNo,
                            'email'         => $email,
                            'country_id'    => $countryCode,
                            'status'        => 'Waiting'
                        ];
                        $response = false;
                        try {
                            $response = $this->_verProcess->saveVerificationCode($data);
                        } catch (\Exception $e) {
                            $returnArray["message"]=  __('Please enter a Pakistani Mobile number in this format 0XXXXXXXXXX.');
                            $returnArray["mobileNumber"] = $mobileNo;
                            return $this->getJsonResponse($returnArray);
                        }

                        if ($response){
                            if ($status==1)
                                $returnArray["message"] = 'The code has been resent to this number '.$mobileNo.'.';
                            else
                                $returnArray["message"] = 'The code has been sent to this number '.$mobileNo.'.';
                            $returnArray["success"] = true;

                        } else {
                            $returnArray["message"] = 'Mobile number is invalid. Please check it.';
                        }
                        $returnArray["mobileNumber"] = $mobileNo;
                        
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch (\Exception $e) {
                $returnArray["message"] = $e->getMessage();
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }