<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Adminhtml\Notification;

    class MassEnable extends \Webkul\Mobikul\Controller\Adminhtml\Notification    {

        public function execute()   {
            $resultRedirect       = $this->resultRedirectFactory->create();
            $collection           = $this->_filter->getCollection($this->_collectionFactory->create());
            $notificationsUpdated = 0;
            $coditionArr          = [];
            foreach ($collection->getAllIds() as $key => $notificationId) {
                $currentNotification = $this->_notificationRepository->getById($notificationId);
                $notificationData = $currentNotification->getData();
                if (count($notificationData)) {
                    $condition = "`id`=".$notificationId;
                    array_push($coditionArr, $condition);
                    $notificationsUpdated++;
                }
            }
            $coditionData = implode(" OR ", $coditionArr);
            $collection->setNotificationData($coditionData, ["status"=>1, "updated_at"=>$this->_date->gmtDate()]);
            if ($notificationsUpdated)
                $this->messageManager->addSuccess(__("A total of %1 record(s) were enabled.", $notificationsUpdated));
            return $resultRedirect->setPath("mobikul/notification/index");
        }

        protected function _isAllowed()     {
            return $this->_authorization->isAllowed("Webkul_Mobikul::notification");
        }

    }