<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Checkout;

    class BillingShippingInfo extends AbstractCheckout   {

        public function execute()   {
            $returnArray                        = [];
            $returnArray["message"]             = "";
            $returnArray["success"]             = false;
            $returnArray["billingAddress"]      = "{}";
            $returnArray["shippingAddress"]     = "{}";
            $returnArray["additionalAddress"]   = [];
            $returnArray["isVirtual"]           = false;
            $returnArray["cartCount"]           = 0;
            try {
                $wholeData       = $this->getRequest()->getPostValue();
                $this->_headers  = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey     = $this->getRequest()->getHeader("authKey");
                    $authData    = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $quoteId     = $wholeData["quoteId"]    ?? 0;
                        $storeId     = $wholeData["storeId"]    ?? 1;
                        $customerId  = $wholeData["customerId"] ?? 0;
                        $environment = $this->_emulate->startEnvironmentEmulation($storeId);
                        $quote       = new \Magento\Framework\DataObject();
                        $addressIds  = [];
                        if($customerId != 0){
                            $customer = $this->_customerFactory->create()->load($customerId);
                            $address  = $customer->getPrimaryBillingAddress();
                            if($address instanceof \Magento\Framework\DataObject){
                                $tempbillingAddress = [];
                                $tempbillingAddress["name"]      = $address->getFirstname().' '.$address->getLastname();
                                $tempbillingAddress["email"]     = $customer->getEmail();
                                $tempbillingAddress["telephone"] = $address->getTelephone();
                                $tempbillingAddress["company"]   = $address->getCompany();
                                $tempbillingAddress["address"]   = implode(',', $address->getStreet()).', '.$address->getCity().', '.$address->getRegion().', '.$address->getCountryModel()->getName();
                                $tempbillingAddress["value"]     = preg_replace("/(<br\ ?\/?>)+/", ", ", rtrim(preg_replace("/(<br\ ?\/?>)+/", "<br>", preg_replace("/[\n\r]/", "<br>", $this->_helperCatalog->stripTags($address->format("html")))), "<br>"));
                                $tempbillingAddress["id"]        = $address->getId();
                                $addressIds[] = $address->getId();
                                $returnArray['billingAddress'] = $tempbillingAddress;
                            }
                            $address = $customer->getPrimaryShippingAddress();
                            if($address instanceof \Magento\Framework\DataObject){
                                $tempshippingAddress = [];
                                $tempshippingAddress["name"]      = $address->getFirstname().' '.$address->getLastname();
                                $tempshippingAddress["email"]     = $customer->getEmail();
                                $tempshippingAddress["telephone"] = $address->getTelephone();
                                $tempshippingAddress["company"]   = $address->getCompany();
                                $tempshippingAddress["address"]   = implode(',', $address->getStreet()).', '.$address->getCity().', '.$address->getRegion().', '.$address->getCountryModel()->getName();
                                $tempshippingAddress["value"]    = preg_replace("/(<br\ ?\/?>)+/", ", ", rtrim(preg_replace("/(<br\ ?\/?>)+/", "<br>", preg_replace("/[\n\r]/", "<br>", $this->_helperCatalog->stripTags($address->format("html")))), "<br>"));
                                $tempshippingAddress["id"]       = $address->getId();
                                $addressIds[] = $address->getId();
                                $returnArray['shippingAddress'] = $tempshippingAddress;
                            }
                            $additionalAddress = $customer->getAdditionalAddresses();
                            foreach($additionalAddress as $eachAdditionalAddress) {
                                if($eachAdditionalAddress instanceof \Magento\Framework\DataObject){
                                    $eachAdditionalAddressArray              = [];
                                    $eachAdditionalAddressArray["name"]      = $eachAdditionalAddress->getFirstname().' '.$eachAdditionalAddress->getLastname();
                                    $eachAdditionalAddressArray["email"]     = $customer->getEmail();
                                    $eachAdditionalAddressArray["telephone"] = $eachAdditionalAddress->getTelephone();
                                    $eachAdditionalAddressArray["company"]   = $eachAdditionalAddress->getCompany();
                                    $eachAdditionalAddressArray["address"]   = implode(',', $eachAdditionalAddress->getStreet()).', '.$eachAdditionalAddress->getCity().', '.$eachAdditionalAddress->getRegion().', '.$eachAdditionalAddress->getCountryModel()->getName();    
                                    $eachAdditionalAddressArray["value"]     = preg_replace("/(<br\ ?\/?>)+/", ", ", rtrim(preg_replace("/(<br\ ?\/?>)+/", "<br>", preg_replace("/[\n\r]/", "<br>", $this->_helperCatalog->stripTags($eachAdditionalAddress->format("html")))), "<br>"));
                                    $eachAdditionalAddressArray["id"]        = $eachAdditionalAddress->getId();
                                    $returnArray['additionalAddress'][] = $eachAdditionalAddressArray;
                                }
                            }
                            $quoteCollection = $this->_quoteFactory->create()
                                ->getCollection()
                                ->addFieldToFilter("customer_id", $customerId)
                                // ->addFieldToFilter("store_id", $storeId)
                                ->addFieldToFilter("is_active", 1)
                                ->addOrder("updated_at", "DESC");
                            $quote = $quoteCollection->getFirstItem();
                        }
                        if($quoteId != 0)
                            $quote = $this->_quoteFactory->create()->setStoreId($storeId)->load($quoteId);
                        if($quote->getItemsQty()*1 == 0){
                            $returnArray["message"] = __("Sorry Something went wrong !!");
                            return $this->getJsonResponse($returnArray);
                        }
                        else{
                            $returnArray["cartCount"] = $quote->getItemsQty()*1;
                        }
                        
                        $returnArray["isVirtual"]  = $quote->isVirtual();
                        
                        $returnArray["success"] = true;
                        $this->_emulate->stopEnvironmentEmulation($environment);
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch(Exception $e)   {
                $returnArray["message"] = $e->getMessage();
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }