<?php
    /**
    * Webkul Software.
    *
    * @category Webkul_Mobikul
    *
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Customer;

    class Login extends AbstractCustomer    {

        public function execute()   {
            $returnArray                  = [];
            $returnArray["success"]       = false;
            $returnArray["message"]       = "";
            $returnArray["cartCount"]     = 0;
            $returnArray["customerId"]    = 0;
            $returnArray["bannerImage"]   = "";
            $returnArray["customerName"]  = "";
            $returnArray["profileImage"]  = "";
            $returnArray["customerEmail"] = "";
            try {
                $wholeData             = $this->getRequest()->getPostValue();
                $this->_headers        = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey           = $this->getRequest()->getHeader("authKey");
                    $authData          = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $width         = $wholeData["width"]     ?? 1000;
                        $token         = $wholeData["token"]     ?? "";
                        $mobile        = $wholeData["mobile"]    ?? 0;
                        $storeId       = $wholeData["storeId"]   ?? 0;
                        $quoteId       = $wholeData["quoteId"]   ?? 0;
                        $mFactor       = $wholeData["mFactor"]   ?? 1;
                        $username      = $wholeData["username"]  ?? "";
                        $password      = $wholeData["password"]  ?? "";
                        $websiteId     = $wholeData["websiteId"] ?? 1;
                        $environment   = $this->_emulate->startEnvironmentEmulation($storeId);
                        $customerModel = $this->_customerFactory->create();
                        // $customer      = $customerModel->setWebsiteId($websiteId)->loadByEmail($username);
                        if ($mobile != 0) {
                            // $collection = Mage::getModel("mobikul/customermobile")->getCollection()->addFieldToFilter("mobile", $mobile);
                            // foreach ($collection as $each) {
                            //     $customer = $customerModel->load($each->getCustomerId());
                            // }
                        } else
                            $customer = $customerModel->setWebsiteId($websiteId)->loadByEmail($username);
                        if($customer->getId() > 0) {
                            $customerId = $customer->getId();
                            $customer = $customerModel->setWebsiteId($websiteId);
                            if($customerModel->getConfirmation() && $customerModel->isConfirmationRequired()) {
                                $returnArray["message"] = __("This account is not confirmed.");
                                return $this->getJsonResponse($returnArray);
                            }
                            $hash = $customerModel->getPasswordHash();
                            $validatePassword = false;
                            if (!$hash)
                                $validatePassword = false;
                            $validatePassword = $this->_encryptor->validateHash($password, $hash);
                            if (!$validatePassword) {
                                $returnArray["message"] = __("Invalid login or password.");
                                return $this->getJsonResponse($returnArray);
                            }
                            $returnArray["customerId"]    = $customerId;
                            $returnArray["customerName"]  = $customer->getName();
                            $returnArray["customerEmail"] = $customer->getEmail();
// Saving Device Token //////////////////////////////////////////////////////////////////////////////////////////////////////////
                            $this->_tokenHelper->saveToken($customer->getId(), $token);
                            $width *= $mFactor;
                            $height = ($width/2)*$mFactor;
                            $profileHeight = $profileWidth = 144 * $mFactor;
                            $collection = $this->_userImage->getCollection()->addFieldToFilter("customer_id", $customer->getId());
                            if ($collection->getSize() > 0) {
                                $time = time();
                                foreach ($collection as $value) {
                                    if ($value->getBanner() != "") {
                                        if ($value->getIsSocial() == 1) {
                                            $returnArray["bannerImage"] = $value->getBanner();
                                        }
                                        else {
                                            $basePath = $this->_baseDir.DS."mobikul".DS."customerpicture".DS.$customerId.DS.$value->getBanner();
                                            $newUrl = "";
                                            if(is_file($basePath)) {
                                                $newPath = $this->_baseDir.DS."mobikul".DS."customerpicture".DS.$customerId.DS.$width."x".$height.DS.$value->getBanner();
                                                $this->_helperCatalog->resizeNCache($basePath, $newPath, $width, $height);
                                                $newUrl = $this->_helper->getUrl("media")."mobikul".DS."customerpicture".DS.$customerId.DS.$width."x".$height.DS.$value->getBanner();
                                            }
                                            $returnArray["bannerImage"] = $newUrl."?".$time;
                                        }
                                    }
                                    if ($value->getProfile() != "") {
                                        if ($value->getIsSocial() == 1) {
                                            $returnArray["profileImage"] = $value->getProfile();
                                        }
                                        else {
                                            $basePath = $this->_baseDir.DS."mobikul".DS."customerpicture".DS.$customerId.DS.$value->getProfile();
                                            $newUrl = "";
                                            if (is_file($basePath)) {
                                                $newPath = $this->_baseDir.DS."mobikul".DS."customerpicture".DS.$customerId.DS.$profileWidth."x".$profileHeight.DS.$value->getProfile();
                                                $this->_helperCatalog->resizeNCache($basePath, $newPath, $profileWidth, $profileHeight);
                                                $newUrl = $this->_helper->getUrl("media")."mobikul".DS."customerpicture".DS.$customerId.DS.$profileWidth."x".$profileHeight.DS.$value->getProfile();
                                            }
                                            $returnArray["profileImage"] = $newUrl."?".$time;
                                        }
                                    }
                                }
                            }
// Merging quest quote with customer quote //////////////////////////////////////////////////////////////////////////////////////
                            $customer = $this->_customerRepositoryInterface->getById($customerId);
                            if($quoteId != 0) {
                                $guestQuote = $this->_quoteFactory->create()->setStoreId($storeId)->load($quoteId);
                                $customerQuote = $this->_quote
                                    ->getCollection()
                                    ->addFieldToFilter("customer_id", $customerId)
                                    ->addFieldToFilter("is_active", 1)
                                    ->addOrder("updated_at", "DESC")
                                    ->getFirstItem();
                                if ($customerQuote->getId() > 0) {
                                    $customerQuote->merge($guestQuote)
                                        ->collectTotals()
                                        ->save();
                                } else {
                                    $guestQuote->assignCustomer($customer)
                                        ->setCustomer($customer)
                                        ->getShippingAddress()
                                        ->setCollectShippingRates(true);
                                    $guestQuote->collectTotals()->save();
                                }
                            }
                            $quote = $this->_quote->getCollection()
                                ->addFieldToFilter("customer_id", $customerId)
                                ->addFieldToFilter("is_active", 1)
                                ->addOrder("updated_at", "DESC")
                                ->getFirstItem();
                            $returnArray["cartCount"] = $quote->getItemsQty() * 1;
                            $returnArray["success"] = true;
                        } else {
                            $returnArray["message"] = __("Invalid login or password.");
                        }
// merging compare list /////////////////////////////////////////////////////////////////////////////////////////////////////////
                        $this->_productCompare->setAllowUsedFlat(false);
                        $items = $this->_productCollectionFactory->create();
                        $items->useProductItem(true)->setStoreId($storeId);
                        $items->setVisitorId($this->_visitor->getId());
                        $attributes = $this->_catalogConfig->getProductAttributes();
                        $items->addAttributeToSelect($attributes)
                            ->loadComparableAttributes()
                            ->setVisibility($this->_productVisibility->getVisibleInSiteIds());
                        foreach ($items as $item) {
                            $item->setCustomerId($customerId);
                            $this->_compareItem->updateCustomerFromVisitor($item);
                            $this->_productCompare->setCustomerId($customerId)->calculate();
                        }
                        $this->_emulate->stopEnvironmentEmulation($environment);
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch (\Exception $e) {
                $returnArray["message"] = __($e->getMessage());
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }