<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Extra;
    use Magento\Store\Model\App\Emulation;
    use Magento\Framework\App\Action\Action;
    use Magento\Framework\App\Action\Context;
    use Webkul\Mobikul\Helper\Data as HelperData;
    use Magento\Framework\Controller\ResultFactory;

    abstract class AbstractMobikul extends \Webkul\Mobikul\Controller\ApiController     {

        protected $_quote;
        protected $_helper;
        protected $_logger;
        protected $_cmsPage;
        protected $_toolbar;
        protected $_baseDir;
        protected $_emulate;
        protected $_visitor;
        protected $_eavConfig;
        protected $_jsonHelper;
        protected $_searchQuery;
        protected $_deviceToken;
        protected $_compareItem;
        protected $_priceHelper;
        protected $_coreSession;
        protected $_imageHelper;
        protected $_blockFactory;
        protected $_storeManager;
        protected $_cataloghelper;
        protected $_catalogConfig;
        protected $_productStatus;
        protected $_filterProvider;
        protected $_productFactory;
        protected $_productCompare;
        protected $_queryCollection;
        protected $_customerSession;
        protected $_filterAttribute;
        protected $_categoryfactory;
        protected $_customerFactory;
        protected $_productVisibility;
        protected $_productCollection;
        protected $_compareCollection;
        protected $_deviceTokenFactory;
        protected $_mobikulNotification;
        protected $_layerFilterAttribute;
        protected $_filterableAttributes;
        protected $_searchSuggestionHelper;
        protected $_helperCatalog;

        public function __construct(
            Context $context,
            HelperData $helper,
            Emulation $emulate,
            \Magento\Cms\Model\Page $cmsPage,
            \Psr\Log\LoggerInterface $logger,
            \Magento\Quote\Model\Quote $quote,
            \Magento\Eav\Model\Config $eavConfig,
            \Magento\Customer\Model\Visitor $visitor,
            \Magento\Search\Model\Query $searchQuery,
            \Webkul\Mobikul\Helper\Token $deviceToken,
            \Magento\Catalog\Helper\Image $imageHelper,
            \Magento\Catalog\Model\Config $catalogConfig,
            \Magento\Checkout\Helper\Data $cataloghelper,
            \Webkul\Mobikul\Helper\Catalog $helperCatalog,
            \Magento\Cms\Model\BlockFactory $blockFactory,
            \Magento\Framework\Json\Helper\Data $jsonHelper,
            \Magento\Framework\Filesystem\DirectoryList $dir,
            \Magento\Customer\Model\Session $customerSession,
            \Magento\Framework\Pricing\Helper\Data $priceHelper,
            \Magento\Catalog\Model\ProductFactory $productFactory,
            \Magento\Catalog\Helper\Product\Compare $productCompare,
            \Magento\Catalog\Model\CategoryFactory $categoryFactory,
            \Magento\Customer\Model\CustomerFactory $customerFactory,
            \Magento\Store\Model\StoreManagerInterface $storeManager,
            \Magento\Cms\Model\Template\FilterProvider $filterProvider,
            \Magento\Catalog\Block\Product\ProductList\Toolbar $toolbar,
            \Webkul\Mobikul\Model\DeviceTokenFactory $deviceTokenFactory,
            \Magento\Catalog\Model\Product\Visibility $productVisibility,
            \Magento\Catalog\Model\Layer\Filter\Attribute $filterAttribute,
            \Webkul\Mobikul\Model\NotificationFactory $mobikulNotification,
            \Webkul\Mobikul\Helper\Searchsuggestion $searchSuggestionHelper,
            \Magento\Framework\Session\SessionManagerInterface $coreSession,
            \Magento\Search\Model\ResourceModel\Query\Collection $queryCollection,
            \Magento\Catalog\Model\Product\Attribute\Source\Status $productStatus,
            \Magento\Catalog\Model\ResourceModel\Product\Compare\Item $compareItem,
            \Magento\Catalog\Model\ResourceModel\Product\Collection $productCollection,
            \Magento\Catalog\Model\ResourceModel\Layer\Filter\Attribute $layerFilterAttribute,
            \Magento\Catalog\Model\Layer\Category\FilterableAttributeList $filterableAttributes,
            \Magento\Catalog\Model\ResourceModel\Product\Compare\Item\CollectionFactory $compareCollection
        ) {
            $this->_quote                  = $quote;
            $this->_logger                 = $logger;
            $this->_helper                 = $helper;
            $this->_visitor                = $visitor;
            $this->_cmsPage                = $cmsPage;
            $this->_emulate                = $emulate;
            $this->_toolbar                = $toolbar;
            $this->_eavConfig              = $eavConfig;
            $this->_jsonHelper             = $jsonHelper;
            $this->_searchQuery            = $searchQuery;
            $this->_imageHelper            = $imageHelper;
            $this->_compareItem            = $compareItem;
            $this->_deviceToken            = $deviceToken;
            $this->_coreSession            = $coreSession;
            $this->_priceHelper            = $priceHelper;
            $this->_storeManager           = $storeManager;
            $this->_blockFactory           = $blockFactory;
            $this->_cataloghelper          = $cataloghelper;
            $this->_catalogConfig          = $catalogConfig;
            $this->_productStatus          = $productStatus;
            $this->_productCompare         = $productCompare;
            $this->_filterProvider         = $filterProvider;
            $this->_productFactory         = $productFactory;
            $this->_filterAttribute        = $filterAttribute;
            $this->_categoryFactory        = $categoryFactory;
            $this->_queryCollection        = $queryCollection;
            $this->_customerSession        = $customerSession;
            $this->_customerFactory        = $customerFactory;
            $this->_compareCollection      = $compareCollection;
            $this->_productVisibility      = $productVisibility;
            $this->_productCollection      = $productCollection;
            $this->_deviceTokenFactory     = $deviceTokenFactory;
            $this->_mobikulNotification    = $mobikulNotification;
            $this->_layerFilterAttribute   = $layerFilterAttribute;
            $this->_filterableAttributes   = $filterableAttributes;
            $this->_baseDir                = $dir->getPath("media");
            $this->_searchSuggestionHelper = $searchSuggestionHelper;
            $this->_helperCatalog          = $helperCatalog;
            parent::__construct($helper, $context);
        }

    }