<?php
    /**
    * Webkul Software.
    *
    * @category Webkul
    *
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Index;

    class UploadBannerPic extends \Webkul\Mobikul\Controller\ApiController  {

        protected $_uploadHelper;

        public function __construct(
            \Webkul\Mobikul\Helper\Data $helper,
            \Magento\Store\Model\App\Emulation $emulate,
            \Webkul\Mobikul\Helper\Upload $uploadHelper,
            \Webkul\Mobikul\Helper\Catalog $helperCatalog,
            \Magento\Framework\App\Action\Context $context
        ) {
            $this->_uploadHelper = $uploadHelper;
            parent::__construct($helper, $context);
        }

        public function execute()   {
            $returnArray            = [];
            $returnArray["url"]     = "";
            $returnArray["message"] = "";
            $returnArray["success"] = false;
            $files           = (array) $this->getRequest()->getFiles();
            if(isset($files)){
                $wholeData   = $this->getRequest()->getParams();
                $width       = $wholeData["width"]      ?? 1000;
                $mFactor     = $wholeData["mFactor"]    ?? 1;
                $customerId  = $wholeData["customerId"] ?? 0;
                $this->_uploadHelper->uploadPicture($files, $customerId, $customerId."-banner", "banner");
                $returnArray = $this->_uploadHelper->resizeAndCache($width, $customerId, $mFactor, "banner");
                return $this->getJsonResponse($returnArray);
            }
            else{
                $returnArray["message"] = __("Invalid Image.");
                return $this->getJsonResponse($returnArray);
            }
        }

    }