<?php


namespace Natz\AccountVerify\Api;

use Magento\Framework\Api\SearchCriteriaInterface;

interface SmslogsRepositoryInterface
{


    /**
     * Save smslogs
     * @param \Natz\AccountVerify\Api\Data\SmslogsInterface $smslogs
     * @return \Natz\AccountVerify\Api\Data\SmslogsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \Natz\AccountVerify\Api\Data\SmslogsInterface $smslogs
    );

    /**
     * Retrieve smslogs
     * @param string $smslogsId
     * @return \Natz\AccountVerify\Api\Data\SmslogsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getById($smslogsId);

    /**
     * Retrieve smslogs matching the specified criteria.
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \Natz\AccountVerify\Api\Data\SmslogsSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete smslogs
     * @param \Natz\AccountVerify\Api\Data\SmslogsInterface $smslogs
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \Natz\AccountVerify\Api\Data\SmslogsInterface $smslogs
    );

    /**
     * Delete smslogs by ID
     * @param string $smslogsId
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($smslogsId);
}
