<?php 
namespace Natz\AccountVerify\Controller\Action;

use Magento\Framework\App\Action\Context;

class CheckAccount extends \Magento\Framework\App\Action\Action
{

    protected $_verProcess;

    protected $resultJsonFactory; 

    protected $_request;

    protected $cart;

    public function __construct(
        Context $context,
        \Natz\AccountVerify\Model\VerificationProcess $verProcess,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Magento\Framework\App\Request\Http $request,
        \Magento\Checkout\Model\Cart $cartData
    )
    {
        parent::__construct($context);
        $this->_verProcess = $verProcess;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->_request = $request;
        $this->cart = $cartData;
    }
    public function execute()
    {   
        $result = $this->resultJsonFactory->create();

        $data['mobile_number']= $this->_request->getPost('mobile_number');
        $data['email']= $this->_request->getPost('email');
        $data['countrycode']= $this->_request->getPost('co');

        $response = $this->_verProcess->validateAccount($data);

        if (count($response)==1){
            if ($response[0]['ver_status']=='Confirmed'){
                $strRet= 'confirmed';
            }else{
                $strRet= 'waiting';
            }
        }else{
            $strRet= 'notverified';
        }

         $result->setData(['resultstatus' => $strRet]);
         return $result;  
    }
}