<?php

namespace Natz\AccountVerify\Helper;

class MessageTemplateParser
{
    /**
     * @var array
     */
    protected $vars;

    /**
     * @var string
     */
    protected $template;

    /**
     * @param string $template
     * @param array $vars
     * @return string
     */
    public function parseTemplate($template, $vars = [])
    {
        $this->template = $template;
        $this->vars = $vars;

        if (preg_match_all('/({{[^{}]*}})/', $template, $matches) > 0) {
            $matches = $this->trimVariableMatches($matches[0]);

            foreach ($matches as $match) {
                $this->template = $this->replacePlaceholderWithVariable($match);
            }
        }

        return $this->template;
    }

    protected function trimVariableMatches($matches)
    {
        $result = [];

        foreach ($matches as $match) {
            $result[] = substr($match, 2, (strlen($match) - 4));
        }

        return $result;
    }

    protected function replacePlaceholderWithVariable($placeholder)
    {
        if (!array_key_exists($placeholder, $this->vars)) {
            return str_replace('{{' . $placeholder . '}}', '', $this->template);
        }
        if (!is_array($this->vars[$placeholder])) {
            return str_replace(
                '{{' . $placeholder . '}}',
                $this->vars[$placeholder],
                $this->template
            );
        }
        if (is_array($this->vars[$placeholder])) {
            return str_replace(
                '{{' . $placeholder . '}}',
                implode(', ', $this->vars[$placeholder]),
                $this->template
            );
        }

        return $this->template;
    }

    public function filterTemplate($string) {
        $string = str_replace(" ", "%20", $string);
        return $string;
    }

    public function filterMobile($string) {
        $string = str_replace("+", "", $string);
        return $string;
    }

    public function updateCountryCode($areacode,$phone,$allowedLength=10)
    {

        $finalPhone = str_replace(" ", "", $phone);
        $phoneLength = strlen($finalPhone);
        $checkStartNumber = substr($finalPhone, 0, 1);

        if ($phoneLength>10 && $checkStartNumber=='0'){
            $mobile = ltrim($finalPhone, '0');  
            return $mobile =$areacode . $mobile;
           
        }elseif ($phoneLength==10){
             return $mobile = $areacode.$finalPhone;
        }else{
            return $phone;
        }
    }


}