<?php

namespace Potato\PerformanceMonitoring\Api;

/**
 * @api
 */
interface CpuRepositoryInterface
{
    /**
     * Create Cpu service
     *
     * @param \Potato\PerformanceMonitoring\Api\Data\CpuInterface $cpu
     * @return \Potato\PerformanceMonitoring\Api\Data\CpuInterface
     * @throws \Magento\Framework\Exception\CouldNotSaveException
     */
    public function save(Data\CpuInterface $cpu);

    /**
     * Get info about Cpu by cpu id
     *
     * @param int $cpuId
     * @return \Potato\PerformanceMonitoring\Api\Data\CpuInterface
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function get($cpuId);

    /**
     * Delete cpu
     *
     * @param \Potato\PerformanceMonitoring\Api\Data\CpuInterface $cpu
     * @return void
     * @throws \Magento\Framework\Exception\InputException
     * @throws \Magento\Framework\Exception\StateException
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function delete(Data\CpuInterface $cpu);

    /**
     * @param string $date
     * @return $this
     */
    public function removeDataByDate($date);

    /**
     * Create new empty cpu model
     * @return \Potato\PerformanceMonitoring\Api\Data\CpuInterface
     */
    public function create();
}
