<?php

namespace Potato\PerformanceMonitoring\Api;

/**
 * @api
 */
interface MemoryRepositoryInterface
{
    /**
     * Create Memory service
     *
     * @param \Potato\PerformanceMonitoring\Api\Data\MemoryInterface $memory
     * @return \Potato\PerformanceMonitoring\Api\Data\MemoryInterface
     * @throws \Magento\Framework\Exception\CouldNotSaveException
     */
    public function save(Data\MemoryInterface $memory);

    /**
     * Get info about Memory by memory id
     *
     * @param int $memoryId
     * @return \Potato\PerformanceMonitoring\Api\Data\MemoryInterface
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function get($memoryId);

    /**
     * Delete memory
     *
     * @param \Potato\PerformanceMonitoring\Api\Data\MemoryInterface $memory
     * @return void
     * @throws \Magento\Framework\Exception\InputException
     * @throws \Magento\Framework\Exception\StateException
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function delete(Data\MemoryInterface $memory);

    /**
     * @param string $date
     * @return $this
     */
    public function removeDataByDate($date);

    /**
     * Create new empty memory model
     * @return \Potato\PerformanceMonitoring\Api\Data\MemoryInterface
     */
    public function create();
}
