<?php

namespace Potato\PerformanceMonitoring\Api;

/**
 * @api
 */
interface TransactionWebRepositoryInterface
{
    /**
     * Create TransactionWeb service
     *
     * @param \Potato\PerformanceMonitoring\Api\Data\TransactionWebInterface $transactionWeb
     * @return \Potato\PerformanceMonitoring\Api\Data\TransactionWebInterface
     * @throws \Magento\Framework\Exception\CouldNotSaveException
     */
    public function save(Data\TransactionWebInterface $transactionWeb);

    /**
     * Get info about TransactionWeb by transactionWeb id
     *
     * @param int $transactionWebId
     * @return \Potato\PerformanceMonitoring\Api\Data\TransactionWebInterface
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function get($transactionWebId);

    /**
     * Delete transactionWeb
     *
     * @param \Potato\PerformanceMonitoring\Api\Data\TransactionWebInterface $transactionWeb
     * @return void
     * @throws \Magento\Framework\Exception\InputException
     * @throws \Magento\Framework\Exception\StateException
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function delete(Data\TransactionWebInterface $transactionWeb);
    
    /**
     * @param string $date
     * @return $this
     */
    public function removeDataByDate($date);

    /**
     * Create new empty transaction web model
     * @return \Potato\PerformanceMonitoring\Api\Data\TransactionWebInterface
     */
    public function create();
}
