<?php

namespace Potato\PerformanceMonitoring\Block\Adminhtml\Form\Tab;

use Magento\Backend\Block\Template;
use Magento\Backend\Block\Widget\Tab\TabInterface;

/**
 * Class Info
 */
class Info extends \Magento\Backend\Block\Widget implements TabInterface
{
    /** @var string  */
    protected $_template = 'Potato_PerformanceMonitoring::tab_info.phtml';
    
    /**
     * Remove styles from phpinfo
     *
     * @return mixed
     */
    public function getInfo()
    {
        ob_start();
        phpinfo();
        $info = ob_get_contents();
        ob_end_clean();
        //remove styling
        return preg_replace( '%^.*<body>(.*)</body>.*$%ms','$1',$info);
    }

    /**
     * Tab settings
     *
     * @return \Magento\Framework\Phrase
     */
    public function getTabLabel()
    {
        return __('PHP Information');
    }

    /**
     * @return \Magento\Framework\Phrase
     */
    public function getTabTitle()
    {
        return __('PHP Information');
    }

    /**
     * @return bool
     */
    public function canShowTab()
    {
        return true;
    }

    /**
     * @return bool
     */
    public function isHidden()
    {
        return false;
    }
}