<?php

namespace Potato\PerformanceMonitoring\Model\Data;

use Magento\Framework\Api\AbstractExtensibleObject;
use Potato\PerformanceMonitoring\Api\Data\MemoryInterface;

/**
 * Class Memory
 */
class Memory extends AbstractExtensibleObject implements MemoryInterface
{
    /**
     * @return int|null
     */
    public function getId()
    {
        return $this->_get(self::ID);
    }

    /**
     * @param int|null $id
     * @return $this
     */
    public function setId($id)
    {
        return $this->setData(self::ID, $id);
    }
    
    /**
     * @return int|null
     */
    public function getValue()
    {
        return $this->_get(self::VALUE);
    }

    /**
     * @param int|null $value
     * @return $this
     */
    public function setValue($value)
    {
        return $this->setData(self::VALUE, $value);
    }
    
    /**
     * @return int|null
     */
    public function getSwap()
    {
        return $this->_get(self::SWAP);
    }

    /**
     * @param int|null $swap
     * @return $this
     */
    public function setSwap($swap)
    {
        return $this->setData(self::SWAP, $swap);
    }
    
    /**
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->_get(self::CREATED_AT);
    }

    /**
     * @param string $createdAt
     * @return $this
     */
    public function setCreatedAt($createdAt)
    {
        return $this->setData(self::CREATED_AT, $createdAt);
    }
        
        

    /**
     * @api
     * @return array
     */
    public function toArray()
    {
        return $this->__toArray();
    }
}
