<?php

namespace Potato\PerformanceMonitoring\Model\Data;

use Magento\Framework\Api\AbstractExtensibleObject;
use Potato\PerformanceMonitoring\Api\Data\TransactionWebInterface;

/**
 * Class TransactionWeb
 */
class TransactionWeb extends AbstractExtensibleObject implements TransactionWebInterface
{
    /**
     * @return int|null
     */
    public function getId()
    {
        return $this->_get(self::ID);
    }

    /**
     * @param int|null $id
     * @return $this
     */
    public function setId($id)
    {
        return $this->setData(self::ID, $id);
    }
    
    /**
     * @return string|null
     */
    public function getPid()
    {
        return $this->_get(self::PID);
    }

    /**
     * @param string|null $pid
     * @return $this
     */
    public function setPid($pid)
    {
        return $this->setData(self::PID, $pid);
    }
                
    /**
     * @return float|null
     */
    public function getCpu()
    {
        return $this->_get(self::CPU);
    }

    /**
     * @param float|null $cpu
     * @return $this
     */
    public function setCpu($cpu)
    {
        return $this->setData(self::CPU, $cpu);
    }
    
    /**
     * @return float|null
     */
    public function getMemory()
    {
        return $this->_get(self::MEMORY);
    }

    /**
     * @param float|null $memory
     * @return $this
     */
    public function setMemory($memory)
    {
        return $this->setData(self::MEMORY, $memory);
    }
    
    /**
     * @return string|null
     */
    public function getUrl()
    {
        return $this->_get(self::URL);
    }

    /**
     * @param string|null $url
     * @return $this
     */
    public function setUrl($url)
    {
        return $this->setData(self::URL, $url);
    }
    
    /**
     * @return int|null
     */
    public function getTime()
    {
        return $this->_get(self::TIME);
    }

    /**
     * @param int|null $time
     * @return $this
     */
    public function setTime($time)
    {
        return $this->setData(self::TIME, $time);
    }
    
    /**
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->_get(self::CREATED_AT);
    }

    /**
     * @param string $createdAt
     * @return $this
     */
    public function setCreatedAt($createdAt)
    {
        return $this->setData(self::CREATED_AT, $createdAt);
    }
    
    /**
     * @api
     * @return array
     */
    public function toArray()
    {
        return $this->__toArray();
    }
}
