<?php
namespace Potato\PerformanceMonitoring\Model\Source;

use Magento\Framework\Data\OptionSourceInterface;
use Potato\PerformanceMonitoring\Model\ResourceModel\TransactionSystem\CollectionFactory as TransactionSystemCollectionFactory;

/**
 * Class Application
 */
class Application implements OptionSourceInterface
{
    /** @var TransactionSystemCollectionFactory  */
    protected $transactionSystemCollectionFactory;

    /**
     * Application constructor.
     * @param TransactionSystemCollectionFactory $transactionSystemCollectionFactory
     */
    public function __construct(
        TransactionSystemCollectionFactory $transactionSystemCollectionFactory
    ) {
        $this->transactionSystemCollectionFactory = $transactionSystemCollectionFactory;
    }
    
    /**
     * @return array
     */
    public function toOptionArray()
    {
        $options = [];
        /** @var \Potato\PerformanceMonitoring\Model\ResourceModel\TransactionSystem\Collection $collection */
        $collection = $this->transactionSystemCollectionFactory->create();
        $collection->getSelect()->reset(\Zend_Db_Select::COLUMNS)->columns('cmd')->distinct(true);
        foreach ($collection as $item) {
            $options[] = [
                'value' => $item->getCmd(),
                'label' => $item->getCmd()
            ];
        }
        return $options;
    }
}