<?php

namespace Potato\PerformanceMonitoring\Model;

/**
 * Class System
 */
class System
{
    /**
     * @return int|\Magento\Framework\Phrase|mixed
     */
    public function getAcceptableLoadAverage()
    {
        $cores = $this->getCpuCoresNumber();
        if ($cores) {
            return $cores + $cores/2;
        }
        return 0;
    }

    /**
     * @return \Magento\Framework\Phrase|mixed
     */
    public function getCpuCoresNumber()
    {
        $result = [];
        $status = [];
        exec('grep -c ^processor /proc/cpuinfo 2>&1', $result, $status);
        if ($status != 0) {
            return __('Error code %s: %s', $status, implode(' ', $result));
        }
        return $result[0];
    }
}