<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_Xlanding
 */


namespace Amasty\Xlanding\Model\Search;

class AdapterFactory extends \Magento\Search\Model\AdapterFactory
{
    /**
     * @var array
     */
    private $adapters;

    public function __construct(
        \Magento\Framework\ObjectManagerInterface $objectManager,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        array $adapters,
        $path,
        $scopeType
    ) {
        $this->adapters = $adapters;
        parent::__construct($objectManager, $scopeConfig, $adapters, $path, $scopeType);
    }

    public function create(array $data = [])
    {
        $currentAdapter = 'mysql'; //Xlanding only works with MySQL
        if (!isset($this->adapters[$currentAdapter])) {
            throw new \LogicException(
                'There is no such adapter: ' . $currentAdapter
            );
        }
        $adapterClass = $this->adapters[$currentAdapter];
        $adapter = $this->objectManager->create($adapterClass, $data);
        if (!($adapter instanceof \Magento\Framework\Search\AdapterInterface)) {
            throw new \InvalidArgumentException(
                'Adapter must implement \Magento\Framework\Search\AdapterInterface'
            );
        }
        return $adapter;
    }
}
