<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_Xlanding
 */


namespace Amasty\Xlanding\Plugin;

use Amasty\Xlanding\Model\Search\AdapterFactory;
use Magento\Framework\Search\RequestInterface;

class SearchEnginePlugin
{
    /**
     * @var AdapterFactory
     */
    protected $adapterFactory;

    /**
     * @var \Magento\Framework\Registry
     */
    protected $coreRegistry;

    /**
     * SearchEnginePlugin constructor.
     * @param AdapterFactory $adapterFactory
     * @param \Magento\Framework\Registry $coreRegistry
     */
    public function __construct(
        AdapterFactory $adapterFactory,
        \Magento\Framework\Registry $coreRegistry
    ) {
        $this->adapterFactory = $adapterFactory;
        $this->coreRegistry = $coreRegistry;
    }

    /**
     * Use only MySQL engine for Landings
     * @param \Magento\Search\Model\SearchEngine $searchEngine
     * @param \Closure $closure
     * @param RequestInterface $request
     * @return \Magento\Framework\Search\Response\QueryResponse|mixed
     */
    public function aroundSearch(
        \Magento\Search\Model\SearchEngine $searchEngine,
        \Closure $closure,
        RequestInterface $request
    ) {
        $page = $this->coreRegistry->registry('amasty_xlanding_page');
        if ($page) {
            return $this->adapterFactory->create()->query($request);
        }

        return $closure($request);
    }
}
