<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_Xlanding
 */


namespace Amasty\Xlanding\Plugin;

class SearchIndexBuilder
{
    /**
     * @var \Magento\Framework\Registry
     */
    private $coreRegistry;

    public function __construct(
        \Magento\Framework\Registry $coreRegistry
    ) {
        $this->coreRegistry = $coreRegistry;
    }

    /**
     * @param \Magento\CatalogSearch\Model\Search\IndexBuilder $indexBuilder
     * @param $select
     * @return mixed
     */
    public function afterBuild(\Magento\CatalogSearch\Model\Search\IndexBuilder $indexBuilder, $select)
    {
        $page = $this->coreRegistry->registry('amasty_xlanding_page');

        /** @var \Amasty\Xlanding\Model\Page $page */
        if ($page) {
            $page->applyAttributesFilter($select);
        }

        return $select;
    }
}
