<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2017 Amasty (https://www.amasty.com)
 * @package Amasty_Shopby
 */


namespace Amasty\ShopbyBase\Helper;

use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\App\Helper\Context;

class Data extends AbstractHelper
{
    const SHOPBY_MODULE_NAME = 'Amasty_Shopby';

    /**
     * @var \Magento\Framework\Module\ModuleList
     */
    private $moduleList;

    /**
     * Data constructor.
     * @param Context $context
     * @param \Magento\Framework\Module\ModuleList $moduleList
     */
    public function __construct(
        Context $context,
        \Magento\Framework\Module\ModuleList $moduleList
    ) {
        parent::__construct($context);
        $this->moduleList = $moduleList;
    }

    /**
     * @return null
     */
    public function getShopbyVersion()
    {
        if ($moduleInformation = $this->moduleList->getOne(self::SHOPBY_MODULE_NAME)) {
            return isset($moduleInformation['version']) ? $moduleInformation['version'] : null;
        }
        return null;
    }

    /**
     * @return bool
     */
    public function isShopbyInstalled()
    {
        return ($this->moduleList->getOne(self::SHOPBY_MODULE_NAME) !== null)
            && ($this->getShopbyVersion() !== null);
    }
}
