<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2017 Amasty (https://www.amasty.com)
 * @package Amasty_Shopby
 */


namespace Amasty\ShopbyBrand\Plugin;

use Magento\Catalog\Model\Layer\Filter\AbstractFilter;
use Amasty\ShopbyBrand\Helper\Content;

class AttributeFilterPlugin
{
    /**
     * @var  Content
     */
    protected $contentHelper;

    public function __construct(Content $contentHelper)
    {
        $this->contentHelper = $contentHelper;
    }

    /**
     * @param AbstractFilter $subject
     * @param bool $result
     * @return bool
     */
    public function afterIsVisibleWhenSelected(AbstractFilter $subject, $result)
    {
        if ($result) {
            if ($this->isBrandingBrand($subject)) {
                $result = false;
            }
        }

        return $result;
    }

    public function afterShouldAddState(AbstractFilter $subject, $result)
    {
        if ($result) {
            if ($this->isBrandingBrand($subject)) {
                $result = false;
            }
        }

        return $result;
    }

    protected function isBrandingBrand(AbstractFilter $subject)
    {
        $brand = $this->contentHelper->getCurrentBranding();
        return $brand &&
            (\Amasty\ShopbyBase\Helper\FilterSetting::ATTR_PREFIX . $subject->getRequestVar() == $brand->getFilterCode());
    }
}
