<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2018 Amasty (https://www.amasty.com)
 * @package Amasty_Xlanding
 */


namespace Amasty\Xlanding\Plugin\Framework\Search\Request;

use Magento\Framework\Search\Request\Builder as MagentoRequestBuilder;
use Magento\Store\Model\StoreManager;

class Builder
{
    /**
     * @var \Magento\Framework\Registry
     */
    private $coreRegistry;

    /**
     * @var \Magento\Framework\EntityManager\EntityMetadataInterface
     */
    private $metadata;

    /**
     * @var StoreManager
     */
    private $storeManager;

    public function __construct(
        \Magento\Framework\Registry $coreRegistry,
        \Magento\Framework\EntityManager\MetadataPool $metadataPool,
        StoreManager $storeManager
    ) {
        $this->coreRegistry = $coreRegistry;
        $this->metadata = $metadataPool->getMetadata(\Magento\Catalog\Api\Data\ProductInterface::class);
        $this->storeManager = $storeManager;
    }

    /**
     * @param MagentoRequestBuilder $subject
     * @return array
     */
    public function beforeCreate(MagentoRequestBuilder $subject)
    {
        /**
         * @var \Amasty\Xlanding\Model\Page $page
         */
        if ($page = $this->coreRegistry->registry('amasty_xlanding_page')) {
            /**
             * @TODO if it will be overflow search request, we can rewrite
             * @ Magento\Framework\Search\Adapter\Mysql\TemporaryStorage::storeApiDocuments
             * @ and filter results there
             */

            $positionData = $page->getProductPositionDataIndex($this->storeManager->getStore()->getId());
            $subject->bind($this->metadata->getLinkField(), array_keys($positionData));
        }

        return [];
    }
}
