<?php
/**
 * @author Azaleasoft Team
 * @copyright Copyright (c) 2016 Azaleasoft (http://www.azaleasoft.com)
 * @package Azaleasoft_Asstorelocator
 */

namespace Azaleasoft\Asstorelocator\Block;

class Head extends \Magento\Framework\View\Element\Template
{
    protected $customerSession;
    protected $objectManager;
    protected $helper;

    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
		\Magento\Framework\ObjectManagerInterface $objectManager,
        array $data = []
    ) {
        parent::__construct($context, $data);

        $this->objectManager   = $objectManager;
        $this->customerSession = $this->objectManager->get('Magento\Customer\Model\Session');
        $this->helper          = $this->objectManager->get('Azaleasoft\Asstorelocator\Helper\Data');
    }

    public function _prepareLayout()
    {
        $this->pageConfig->setKeywords($this->helper->getMetaKeywords());
        $this->pageConfig->setDescription($this->helper->getMetaDescription());

        return parent::_prepareLayout();
    }  
}