<?php
/**
 * @author Azaleasoft Team
 * @copyright Copyright (c) 2016 Azaleasoft (http://www.azaleasoft.com)
 * @package Azaleasoft_Asstorelocator
 */
namespace Azaleasoft\Asstorelocator\Controller\Adminhtml\Index;

class Delete extends \Magento\Backend\App\Action
{
    protected $_coreRegistry = null;

    protected $resultPageFactory;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Registry $registry
    ) {
        $this->resultPageFactory = $resultPageFactory;
        $this->_coreRegistry     = $registry;
        parent::__construct($context);
    }


    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        $model = $this->_objectManager->create('Azaleasoft\Asstorelocator\Model\Asstorelocator');

        if ($id) {
            $model->load($id);
        }

        if (!$model->getId()) {
            $this->messageManager->addError(__('This store no longer exists.'));
            $this->_redirect('*/*/');
            return;
        }

        try {
            $model->delete();
            $this->messageManager->addSuccess(__('The store has been deleted.'));

            $this->_redirect('*/*/');
            return;
        } catch(\Exception $e) {
            $this->messageManager->addError($e->getMessage());
            $this->_redirect('*/*/edit', ['id' => $id]);
        }
    }


    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Azaleasoft_Asstorelocator::config_asstorelocator');
    }
}