<?php
/**
 * @author Azaleasoft Team
 * @copyright Copyright (c) 2016 Azaleasoft (http://www.azaleasoft.com)
 * @package Azaleasoft_Asstorelocator
 */
namespace Azaleasoft\Asstorelocator\Controller\Adminhtml\Index;

class Save extends \Magento\Backend\App\Action
{
    protected $_coreRegistry;

    protected $resultPageFactory;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Registry $registry
    ) {
        $this->resultPageFactory = $resultPageFactory;
        $this->_coreRegistry     = $registry;
        parent::__construct($context);
    }


    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Azaleasoft_Asstorelocator::config_asstorelocator');
    }


    public function execute()
    {
        if (!$this->getRequest()->isPost()) {
            $this->_redirect('*/*/');
        }
        $id = $this->getRequest()->getParam('id');
        $model = $this->_objectManager->create('Azaleasoft\Asstorelocator\Model\Asstorelocator');

        $data = $this->getRequest()->getPostValue();
        if ($id) {
            $model->load($id);
        }
        $model->setData($data);
        if ($id) {
            $model->setUpdatedAt($this->_objectManager->get('Magento\Framework\Stdlib\DateTime\DateTime')->gmtDate());
        } else {
            $model->setCreatedAt($this->_objectManager->get('Magento\Framework\Stdlib\DateTime\DateTime')->gmtDate());
        }
        try {
            $model->save();
            $this->_objectManager->get('Azaleasoft\Asstorelocator\Helper\Data')->getLatLngByAddress($model->getId());
            $this->messageManager->addSuccess(__('The store has been saved.'));

            $this->_redirect('*/*/');
            return;
        } catch(\Exception $e) {
            $this->messageManager->addError($e->getMessage());
        }

        $this->_getSession()->setFormData($data);
        $this->_redirect('*/*/edit', ['id' => $id]);
    }

}