<?php
/**
 * @author Azaleasoft Team
 * @copyright Copyright (c) 2016 Azaleasoft (http://www.azaleasoft.com)
 * @package Azaleasoft_Asstorelocator
 */
namespace Azaleasoft\Asstorelocator\Controller;

class Router implements \Magento\Framework\App\RouterInterface
{
	protected $actionFactory;
	protected $_response;
	protected $helper;

	public function __construct(
		\Magento\Framework\App\ActionFactory $actionFactory,
		\Azaleasoft\Asstorelocator\Helper\Data $helper,
        \Magento\Framework\App\ResponseInterface $response
	) {
		$this->actionFactory = $actionFactory;
        $this->_response = $response;
        $this->helper = $helper;
    }

    public function match(\Magento\Framework\App\RequestInterface $request)
    {
    	$path = trim($request->getPathInfo(), '/');
    	$identifier = explode('/', $path)[0];
    	if($identifier === $this->helper->getStoreUrl()) {
    		$request->setModuleName('asstorelocator')->setControllerName('index')->setActionName('index');
    	} else {
    		return;
    	}

    	return $this->actionFactory->create(
    		'Magento\Framework\App\Action\Forward',
    		['request' => $request]
        );
    }
}