<?php
/**
 * @author Azaleasoft Team
 * @copyright Copyright (c) 2016 Azaleasoft (http://www.azaleasoft.com)
 * @package Azaleasoft_Asstorelocator
 */
namespace Azaleasoft\Asstorelocator\Plugin;

class TopmenuPlugin
{
    protected $_objectManager;
    protected $_helper;

    public function __construct(
        \Magento\Framework\ObjectManagerInterface $objectManager,
        \Azaleasoft\Asstorelocator\Helper\Data $dataHelper)
    {
        $this->_objectManager = $objectManager;
        $this->_helper = $dataHelper;
    }

    public function afterGetHtml(\Magento\Theme\Block\Html\Topmenu $topmenu, $html)
    {
        if(!$this->_helper->getTopmenuIsEnabled()) {
            return $html;
        }
        
        $html .= "<li class=\"level0 nav-4 level-top parent ui-menu-item\" role=\"presentation\">";
        $html .= "<a href=\"" . $this->_helper->getFullUrl() . "\" class=\"level-top ui-corner-all\" aria-haspopup=\"true\" tabindex=\"-1\" role=\"menuitem\"><span>" . __($this->_helper->getLinkName()) . "</span></a>";
        $html .= "</li>";

        return $html;
    }
}