<?php
/**
 * BSS Commerce Co.
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the EULA
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://bsscommerce.com/Bss-Commerce-License.txt
 *
 * =================================================================
 *                 MAGENTO EDITION USAGE NOTICE
 * =================================================================
 * This package designed for Magento COMMUNITY edition
 * BSS Commerce does not guarantee correct work of this extension
 * on any other Magento edition except Magento COMMUNITY edition.
 * BSS Commerce does not provide extension support in case of
 * incorrect edition usage.
 * =================================================================
 *
 * @category   BSS
 * @package    Bss_ReorderProduct
 * @author     Extension Team
 * @copyright  Copyright (c) 2015-2016 BSS Commerce Co. ( http://bsscommerce.com )
 * @license    http://bsscommerce.com/Bss-Commerce-License.txt
 */
namespace Bss\ReorderProduct\Model\ResourceModel\OrderItem;

class Collection extends \Magento\Sales\Model\ResourceModel\Order\Item\Collection
{
    public function filterOrderIds($_orderids)
    {
        $this->addFieldToFilter('order_id', ['in' => $_orderids]);
        $this->addFieldToFilter('parent_item_id', ['null' => true]);
        $this->getSelect()
                    ->columns('MAX(item_id) as reoder_item_id')
                    ->columns('SUM(qty_ordered) as reoder_qty_ordered')
                    ->group(['reorder_item_options', 'sku']);
        return $this;
    }

    public function getChildProduct($parent_item_id)
    {
        $this->addFieldToFilter('parent_item_id',$parent_item_id);
        return $this;
    }
}
