<?php
/**
 * BSS Commerce Co.
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the EULA
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://bsscommerce.com/Bss-Commerce-License.txt
 *
 * =================================================================
 *                 MAGENTO EDITION USAGE NOTICE
 * =================================================================
 * This package designed for Magento COMMUNITY edition
 * BSS Commerce does not guarantee correct work of this extension
 * on any other Magento edition except Magento COMMUNITY edition.
 * BSS Commerce does not provide extension support in case of
 * incorrect edition usage.
 * =================================================================
 *
 * @category   BSS
 * @package    Bss_ReorderProduct
 * @author     Extension Team
 * @copyright  Copyright (c) 2015-2016 BSS Commerce Co. ( http://bsscommerce.com )
 * @license    http://bsscommerce.com/Bss-Commerce-License.txt
 */
namespace Bss\ReorderProduct\Setup;

use Magento\Framework\Setup\InstallSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

class InstallSchema implements InstallSchemaInterface
{
    public function install(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $setup->startSetup();
        $tableName = $setup->getTable('sales_order_item');
 
        $setup->getConnection()->addColumn(
            $setup->getTable('sales_order_item'),
            'reorder_item_options',
            [
                'type' => \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                'nullable' => true,
                'comment' => 'Options'
            ]
        );

        $setup->endSetup();

        $collection  = \Magento\Framework\App\ObjectManager::getInstance()->create('Magento\Sales\Model\ResourceModel\Order\Item\Collection');
        foreach ($collection as $item) {
            $itemOptionValue = $item->getProductOptions();
            foreach (['qty', 'uenc', 'form_key'] as $key) {
                unset($itemOptionValue['info_buyRequest'][$key]);
            }
            $data = serialize($itemOptionValue['info_buyRequest']);

            $item->setReorderItemOptions($data);
            try {
                $item->save();
            } catch (\Exception $e) {
               
            }
        }
    }
}
