<?php namespace MageArray\SocialLogin\Block;

use Magento\Customer\Model\Form;
use Magento\Customer\Model\Session;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;
use Magento\Store\Model\ScopeInterface;

/**
 * Class Login
 * @package MageArray\SocialLogin\Block
 */
class Login extends Template
{
    /**
     * @var
     */
    protected $_buttons;
    /**
     * @var Session
     */
    protected $_customerSession;

    /**
     * Login constructor.
     * @param Context $context
     * @param Session $customerSession
     */
    public function __construct(
        Context $context,
        Session $customerSession
    ) {
        $this->_customerSession = $customerSession;
        parent::__construct($context);
        $this->setTemplate('MageArray_SocialLogin::form/type.phtml');
    }

    /**
     * @return string
     */
    protected function _toHtml()
    {
        $this->setModuleName(
            $this->extractModuleName('Magento\Customer\Block\Form\Login'));
        return parent::_toHtml();
    }

    /**
     * @return bool
     */
    public function isAutocompleteDisabled()
    {
        return (bool)!$this->_scopeConfig
            ->getValue(Form::XML_PATH_ENABLE_AUTOCOMPLETE,
                ScopeInterface::SCOPE_STORE);
    }

    /**
     * @return bool
     */
    public function isCustomerLoggedIn()
    {
        return $this->_customerSession->isLoggedIn();
    }
}    