<?php
namespace MageArray\SocialLogin\Block\Login;

use Magento\Customer\Model\Session;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\Element\Template\Context;
use Magento\Store\Model\ScopeInterface;

/**
 * Class Type
 * @package MageArray\SocialLogin\Block\Login
 */
class Type extends Template
{
    /**
     * @var
     */
    protected $_class;
    /**
     * @var
     */
    protected $_spanclass;
    /**
     * @var
     */
    protected $_title;
    /**
     * @var
     */
    protected $_name;
    /**
     * @var
     */
    protected $_width;
    /**
     * @var
     */
    protected $_height;
    /**
     * @var null
     */
    protected $_client = null;
    /**
     * @var null
     */
    protected $_userInfo = null;
    /**
     * @var
     */
    protected $_disconnect;
    /**
     * @var Session
     */
    protected $_customerSession;

    /**
     * Type constructor.
     * @param Context $context
     * @param Session $customerSession
     */
    public function __construct(
        Context $context,
        Session $customerSession
    ) {
        $this->_customerSession = $customerSession;
        parent::__construct($context);
        $this->setTemplate('MageArray_SocialLogin::form/type.phtml'); 
    }

    /**
     * @return mixed
     */
    public function getClass()
    {
        return $this->_class;
    }

    /**
     * @return mixed
     */
    public function getSpanClass()
    {
        return $this->_spanclass;
    }

    /**
     * @return mixed
     */
    public function getTitle()
    {
        return $this->_title;
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->_name;
    }

    /**
     * @return mixed
     */
    public function getWidth()
    {
        return $this->_width;
    }

    /**
     * @return mixed
     */
    public function getHeight()
    {
        return $this->_height;
    }

    /**
     * @return mixed
     */
    public function getDisconnect()
    {
        return $this->_disconnect;
    }

    /**
     * @return string
     */
    public function getUrlDisconnect()
    {
        $url = $this->getUrl($this->getDisconnect());
        return $url;
    }

    /**
     * @param $class
     */
    public function setClass($class)
    {
        $this->_class = $class;
    }

    /**
     * @param $spanclass
     */
    public function setSpanClass($spanclass)
    {
        $this->_spanclass = $spanclass;
    }

    /**
     * @param $title
     */
    public function setTitle($title)
    {
        $this->_title = $title;
    }

    /**
     * @param $name
     */
    public function setName($name)
    {
        $this->_name = $name;
    }

    /**
     * @param $width
     */
    public function setWidth($width)
    {
        $this->_width = $width;
    }

    /**
     * @param $height
     */
    public function setHeight($height)
    {
        $this->_height = $height;
    }

    /**
     * @param $disconnect
     */
    public function setDisconnect($disconnect)
    {
        $this->_disconnect = $disconnect;
    }

    /**
     * @return string
     */
    public function render()
    {
        return $this->toHtml();
    }

    /**
     * @return string
     */
    public function _getXmlPath()
    {
        $data = 'magearray_social/' . $this->getName() . '/enabled';
        return $data;
    }

    /**
     * @return bool
     */
    public function checkEnable()
    {
        $result = false;
        $enabled = $this->getStoreConfig($this->_getXmlPath());
        if ($enabled == 1) {
            $result = true;
        }
        return $result;
    }

    /**
     * @return string
     */
    public function getButtonUrl()
    {
        if (empty($this->_userInfo)) {
            return $this->getConnect();
        } else {
            return $this->getUrlDisconnect();
        }
    }

    /**
     * @param $path
     * @return mixed
     */
    public function getStoreConfig($path)
    {
        return $this->_scopeConfig
            ->getValue($path, ScopeInterface::SCOPE_STORE);
    }

    /**
     * @return bool
     */
    public function isCustomerLoggedIn()
    {
        return $this->_customerSession->isLoggedIn();
    }

} 