<?php
namespace MageArray\SocialLogin\Block\Login\Type;

use MageArray\SocialLogin\Block\Login\Type;
use Magento\Customer\Model\Session;
use Magento\Store\Model\ScopeInterface;

/**
 * Class Yahoo
 * @package MageArray\SocialLogin\Block\Login\Type
 */
class Yahoo extends Type
{
    /**
     * @var string
     */
    protected $_class = 'btn-yahoo';
    /**
     * @var string
     */
    protected $_spanclass = 'fa-yahoo';
    /**
     * @var string
     */
    protected $_title = 'Yahoo';
    /**
     * @var string
     */
    protected $_name = 'yahoo';
    /**
     * @var int
     */
    protected $_width = 600;
    /**
     * @var int
     */
    protected $_height = 500;
    /**
     * @var string
     */
    protected $_disconnect = 'sociallogin/yahoo/disconnect';
    /**
     * @var string
     */
    protected $_protocol = 'http';

    /**
     * @return string
     */
    public function getConnect()
    {
        $connect = $this
                ->getBaseUrl() . 'sociallogin/yahoo/request/mainw_protocol/'
            . $this->_protocol;
        return $connect;
    }

    /**
     * @return mixed
     */
    public function getBaseUrl()
    {
        return $this->_storeManager->getStore()->getBaseUrl();
    }

    /**
     * @return mixed
     */
    public function showLongIcon()
    {
        $enabled = $this->getStoreConfig(
            'magearray_social/general/show_long_icon'
        );
        return $enabled;
    }

    /**
     * @param $path
     * @return mixed
     */
    public function getStoreConfig($path)
    {
        return $this
            ->_scopeConfig
            ->getValue($path, ScopeInterface::SCOPE_STORE);
    }
}