<?php
namespace MageArray\SocialLogin\Controller\Facebook;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use MageArray\SocialLogin\Helper\Facebook;
use Magento\Backend\Model\Session;

/**
 * Class Request
 * @package MageArray\SocialLogin\Controller\Facebook
 */
class Request extends Action
{
    /**
     * @var Facebook
     */
    protected $_fbHelper;
    /**
     * @var Session
     */
    protected $_session;

    /**
     * Request constructor.
     * @param Context $context
     * @param Session $session
     * @param Facebook $_fbHelper
     */
    public function __construct(
        Context $context,
        Session $session,
        Facebook $_fbHelper
    )
    {
        $this->_fbHelper = $_fbHelper;
        $this->_session = $session;
        parent::__construct($context);
    }

    /**
     * @return mixed
     */
    public function execute()
    {
        $resultRedirect = $this->resultRedirectFactory->create();
        $this->_session->setFacebookCsrf($csrf = md5(uniqid(rand(), true)));
        $this->_fbHelper->setState($csrf);

        $mainwProtocol = $this->getRequest()->getParam('mainw_protocol');
        $this->_session->setIsSecure($mainwProtocol);
        return $resultRedirect->setUrl($this->_fbHelper->createRequestUrl());
    }
}