<?php
namespace MageArray\SocialLogin\Controller\Google;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use MageArray\SocialLogin\Helper\Google;
use Magento\Backend\Model\Session;

/**
 * Class Request
 * @package MageArray\SocialLogin\Controller\Google
 */
class Request extends Action
{
    /**
     * @var Google
     */
    protected $_goHelper;
    /**
     * @var Session
     */
    protected $_session;

    /**
     * Request constructor.
     * @param Context $context
     * @param Session $session
     * @param Google $_goHelper
     */
    public function __construct(
        Context $context,
        Session $session,
        Google $_goHelper
    ) {
        $this->_goHelper = $_goHelper;
        $this->_session = $session;
        parent::__construct($context);
    }

    /**
     * @return $this
     */
    public function execute()
    {
        $resultRedirect = $this->resultRedirectFactory->create();
        $this->_session->setGoogleCsrf($csrf = md5(uniqid(rand(), true)));
        $this->_goHelper->setState($csrf);

        $mainwProtocol = $this->getRequest()->getParam('mainw_protocol');
        $this->_session->setIsSecure($mainwProtocol);
        return $resultRedirect->setUrl($this->_goHelper->createRequestUrl());
    }
}