<?php
namespace MageArray\SocialLogin\Controller\Live;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use MageArray\SocialLogin\Helper\Live;
use Magento\Backend\Model\Session;

/**
 * Class Request
 * @package MageArray\SocialLogin\Controller\Live
 */
class Request extends Action
{
    /**
     * @var Live
     */
    protected $_liHelper;
    /**
     * @var Session
     */
    protected $_session;

    /**
     * Request constructor.
     * @param Context $context
     * @param Session $session
     * @param Live $_liHelper
     */
    public function __construct(
        Context $context,
        Session $session,
        Live $_liHelper
    ) {
        $this->_liHelper = $_liHelper;
        $this->_session = $session;
        parent::__construct($context);
    }

    /**
     * @return $this
     */
    public function execute()
    {
        $resultRedirect = $this->resultRedirectFactory->create();
        $this->_session->setLiveCsrf($csrf = md5(uniqid(rand(), true)));
        $this->_liHelper->setState($csrf);

        $mainwProtocol = $this->getRequest()->getParam('mainw_protocol');
        $this->_session->setIsSecure($mainwProtocol);
        return $resultRedirect->setUrl($this->_liHelper->createRequestUrl());
    }
}