<?php
namespace MageArray\SocialLogin\Controller\Twitter;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use MageArray\SocialLogin\Helper\Twitter;
use Magento\Backend\Model\Session;

/**
 * Class Request
 * @package MageArray\SocialLogin\Controller\Twitter
 */
class Request extends Action
{
    /**
     * @var Twitter
     */
    protected $_twHelper;
    /**
     * @var Session
     */
    protected $_session;

    /**
     * Request constructor.
     * @param Context $context
     * @param Session $session
     * @param Twitter $_twHelper
     */
    public function __construct(
        Context $context,
        Session $session,
        Twitter $_twHelper
    ) {
        $this->_twHelper = $_twHelper;
        $this->_session = $session;
        parent::__construct($context);
    }

    /**
     *
     */
    public function execute()
    {

        $mainwProtocol = $this->getRequest()->getParam('mainw_protocol');
        $this->_session->setIsSecure($mainwProtocol);
        $this->_twHelper->fetchRequestToken();

    }
}