<?php
namespace MageArray\SocialLogin\Controller\Yahoo;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use MageArray\SocialLogin\Helper\Yahoo;
use Magento\Backend\Model\Session;

/**
 * Class Request
 * @package MageArray\SocialLogin\Controller\Yahoo
 */
class Request extends Action
{
    /**
     * @var Yahoo
     */
    protected $_yaHelper;
    /**
     * @var Session
     */
    protected $_session;

    /**
     * Request constructor.
     * @param Context $context
     * @param Session $session
     * @param Yahoo $_yaHelper
     */
    public function __construct(
        Context $context,
        Session $session,
        Yahoo $_yaHelper
    ) {
        $this->_yaHelper = $_yaHelper;
        $this->_session = $session;
        parent::__construct($context);
    }

    /**
     * @return $this
     */
    public function execute()
    {
        $resultRedirect = $this->resultRedirectFactory->create();
        $this->_session->setYahooCsrf($csrf = md5(uniqid(rand(), true)));
        $this->_yaHelper->setState($csrf);

        $mainwProtocol = $this->getRequest()->getParam('mainw_protocol');
        $this->_session->setIsSecure($mainwProtocol);
        return $resultRedirect->setUrl($this->_yaHelper->createRequestUrl());
    }
}