/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
/*jshint browser:true jquery:true*/
/*global alert*/
define(
    [	
		'ko',
        'jquery',
        'Magento_Ui/js/modal/modal',
		'mage/template',
		'jquery/ui',
		'MageArray_SocialLogin/js/sociallogin'
    ],
    function (ko, $, modal, nbImageTplt, ui, sociallogin) {
        'use strict';

        return {
            modalWindow: null,

            /** Create popUp window for provided element */
            createPopUp: function (element) {
                this.modalWindow = element;
                var options = {
                    'type': 'popup',
                    'modalClass': 'popup-authentication',
                    'responsive': true,
                    'innerScroll': true,
                    'trigger': '.proceed-to-checkout',
                    'buttons': []
                };
                modal(options, $(this.modalWindow));
            },

            /** Show login popup window */
            showModal: function () {
				var baseURL = window.location.protocol + "//" + window.location.host;
				var url = window.location.pathname;
				var path = url.replace('customer/account/login/', '');
				var createpath = url.replace('customer/account/create/', '');
				var loginUrl = baseURL + path + 'customer/account/login/';
				var createUrl = baseURL + createpath + 'customer/account/create/';
				
				if(baseURL + url == loginUrl){
					if(!$('[data-role=focusable-scope] .modal-header').find('.social-login-container').length){
						jQuery('.social-login-container').clone().appendTo('[data-role=focusable-scope] .modal-header');
						$('.btn-social-icon').css({'margin-right':'5px','cursor':'pointer','box-shadow':'none'});
					
						$('.btn-social').css({'margin-right':'5px','cursor':'pointer','box-shadow':'none','width':'220px','margin-bottom':'5px'});
					}
				}else if(baseURL + url == createUrl){
					if(!$('[data-role=focusable-scope] .modal-header').find('.social-login-container').length){
						jQuery('.social-login-container').clone().appendTo('[data-role=focusable-scope] .modal-header');
						$('.btn-social-icon').css({'margin-right':'5px','cursor':'pointer','box-shadow':'none'});
					
						$('.btn-social').css({'margin-right':'5px','cursor':'pointer','box-shadow':'none','width':'220px','margin-bottom':'5px'});
					}
				}else{
					this.facebook = nbImageTplt('[data-template=magearray-social-popup-facebook]');
					this.google = nbImageTplt('[data-template=magearray-social-popup-google]');
					this.twitter = nbImageTplt('[data-template=magearray-social-popup-twitter]'); 
					this.linkedin = nbImageTplt('[data-template=magearray-social-popup-linkedin]'); 
					this.yahoo = nbImageTplt('[data-template=magearray-social-popup-yahoo]'); 
					this.live = nbImageTplt('[data-template=magearray-social-popup-live]'); 
					this.social = nbImageTplt('[data-template=magearray-social-popup-social]'); 
					
					if(!$('[data-role=focusable-scope] .modal-header').find('.sociallogin-social').length){
						
						$('[data-role=focusable-scope] .modal-header').append(this.social()); 
					}
					
					if(!$('[data-role=focusable-scope] .modal-header').find('.btn-facebook').length){
						
						$('[data-role=focusable-scope] .modal-header').append(this.facebook()); 
					}
					if(!$('[data-role=focusable-scope] .modal-header').find('.btn-google').length){
						
						$('[data-role=focusable-scope] .modal-header').append(this.google()); 
					}
					
					if(!$('[data-role=focusable-scope] .modal-header').find('.btn-linkedin').length){
						
						$('[data-role=focusable-scope] .modal-header').append(this.linkedin()); 
					}
					
					if(!$('[data-role=focusable-scope] .modal-header').find('.btn-twitter').length){
						
						$('[data-role=focusable-scope] .modal-header').append(this.twitter()); 
					}
					
					if(!$('[data-role=focusable-scope] .modal-header').find('.btn-yahoo').length){
						
						$('[data-role=focusable-scope] .modal-header').append(this.yahoo()); 
					}
					
					if(!$('[data-role=focusable-scope] .modal-header').find('.btn-microsoft').length){
						
						$('[data-role=focusable-scope] .modal-header').append(this.live()); 
					}
					
					$('.btn-social-icon').css({'margin-right':'5px','cursor':'pointer','box-shadow':'none'});
					
					$('.btn-social').css({'margin-right':'5px','cursor':'pointer','box-shadow':'none','width':'220px'});
				}
					
                $(this.modalWindow).modal('openModal'); 
            }
        } 
    }
);
