<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_AbandonedCart
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\AbandonedCart\Controller\Adminhtml;

/**
 * Class AbandonedCart
 * @package Mageplaza\AbandonedCart\Controller\Adminhtml
 */
abstract class AbandonedCart extends \Magento\Backend\App\Action
{
	/**
	 * Authorization level of a basic admin session
	 *
	 * @see _isAllowed()
	 */
	const ADMIN_RESOURCE = 'Mageplaza_AbandonedCart::abandonedcart';

	/**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    protected $resultPageFactory;

    /**
     * @var \Magento\Framework\Json\Helper\Data
     */
    protected $jsonHelper;

    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $logger;

    /**
     * @var \Mageplaza\AbandonedCart\Model\ResourceModel\Logs
     */
    protected $abandonedCartLog;

    /**
     * @var \Mageplaza\AbandonedCart\Model\LogsFactory
     */
    protected $logsFactory;

    /**
     * @var \Mageplaza\AbandonedCart\Model\AbandonedCart
     */
    protected $abandonedCartModel;

    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     * @param \Magento\Framework\Json\Helper\Data $jsonHelper
     * @param \Psr\Log\LoggerInterface $logger
     * @param \Mageplaza\AbandonedCart\Model\ResourceModel\Logs $abandonedCartLog
     * @param \Mageplaza\AbandonedCart\Model\LogsFactory $logsFactory
     * @param \Mageplaza\AbandonedCart\Model\AbandonedCart $abandonedCartModel
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Json\Helper\Data $jsonHelper,
        \Psr\Log\LoggerInterface $logger,
        \Mageplaza\AbandonedCart\Model\ResourceModel\Logs $abandonedCartLog,
        \Mageplaza\AbandonedCart\Model\LogsFactory $logsFactory,
        \Mageplaza\AbandonedCart\Model\AbandonedCart $abandonedCartModel
    ) {
        parent::__construct($context);
        $this->resultPageFactory = $resultPageFactory;
        $this->jsonHelper        = $jsonHelper;
        $this->logger = $logger;
        $this->abandonedCartLog = $abandonedCartLog;
        $this->logsFactory = $logsFactory;
        $this->abandonedCartModel = $abandonedCartModel;
    }

	/**
     * Initiate action
     *
     * @return this
     */
    protected function _initAction()
    {
        $this->_view->loadLayout();
        $this->_setActiveMenu('Mageplaza_AbandonedCart::abandonedcart')->_addBreadcrumb(__('AbandonedCart'), __('Logs'));
        return $this;
    }
}
