<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_AbandonedCart
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\AbandonedCart\Controller\Adminhtml\Index;

/**
 * Class Ajax
 * @package Mageplaza\AbandonedCart\Controller\Adminhtml\Index
 */
class Ajax extends \Mageplaza\AbandonedCart\Controller\Adminhtml\AbandonedCart
{
	/**
	 * @return \Magento\Framework\View\Result\Page
	 */
	public function execute()
	{
		$resultPage = $this->resultPageFactory->create();
        $fromDate = $this->getRequest()->getParam('from');
        $toDate = $this->getRequest()->getParam('to');
        $dimension = $this->getRequest()->getParam('dimension');
        $result = [];
        $result['status'] = false;
		try {
            if ($fromDate && $toDate && strtotime($fromDate) <= strtotime($toDate)) {
                $data = $this->abandonedCartLog->loadReportData($fromDate, $toDate, $dimension);
                $reportData = json_encode($data);
    			$html = $resultPage->getLayout()
                            ->createBlock('Magento\Backend\Block\Template')
                            ->setTemplate('Mageplaza_AbandonedCart::report/content.phtml')
                            ->setReportData($reportData)
                            ->toHtml();
    			$result['content'] = $html;
    			$result['status'] = true;
            }
		} catch (\Exception $e) {
            $this->logger->critical($e);
        }
        $this->getResponse()->representJson(
            $this->jsonHelper->jsonEncode($result)
        );
	}
}
