<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_AbandonedCart
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\AbandonedCart\Controller\Adminhtml\Index;

/**
 * Class Delete
 * @package Mageplaza\AbandonedCart\Controller\Adminhtml\Index
 */
class Delete extends \Mageplaza\AbandonedCart\Controller\Adminhtml\AbandonedCart
{
	/**
     * Delete abandoned cart email log
     *
     * @return void
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        try {
            if ($id) {
                $log = $this->logsFactory->create()->load($id);
                if ($log->getId()) {
                    $log->setDisplay(false)->save();
                    $this->messageManager->addSuccess(__('Delete success.'));
                }
            }
        } catch (\Exception $e) {
            $this->messageManager->addError(__('Error.'));
        }
        $this->_redirect('abandonedcart/*/logs');
    }
}
