<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_AbandonedCart
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\AbandonedCart\Cron;

/**
 * Class AbandonedCart
 * @package Mageplaza\AbandonedCart\Cron
 */
class AbandonedCart
{
    /**
     * @var \Psr\Log\LoggerInterface
     */
    private $logger;

    /**
     * @var \Mageplaza\AbandonedCart\Model\AbandonedCart
     */
    private $abandonedCartModel;

    /**
     * @var \Mageplaza\AbandonedCart\Helper\Data
     */
    private $helperData;

    /**
     * Constructor
     *
     * @param \Psr\Log\LoggerInterface $logger
     * @param \Mageplaza\AbandonedCart\Model\AbandonedCart $abandonedCartModel
     */
    public function __construct(
        \Psr\Log\LoggerInterface $logger,
        \Mageplaza\AbandonedCart\Model\AbandonedCart $abandonedCartModel,
        \Mageplaza\AbandonedCart\Helper\Data $helperData
    ) {
        $this->logger = $logger;
        $this->abandonedCartModel = $abandonedCartModel;
        $this->helperData = $helperData;
    }

    /**
     * @return void
     */
    public function execute()
    {
        $this->logger->critical('jimmy - cron run');
        if ($this->helperData->isEnabled()) {
            $this->logger->critical('jimmy - enabled abandonedCart');
            try {
                $this->abandonedCartModel->prepareForAbandonedCart();
            } catch (\Exception $e) {
                $this->logger->critical($e);
            }
        }
    }
}
