<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_AbandonedCart
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\AbandonedCart\Model\Config\Source;

use Magento\SalesRule\Helper\Coupon;

/**
 * Class Format
 * @package Mageplaza\AbandonedCart\Model\Config\Source
 */
class Format implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * Return array of options as value-label pairs
     *
     * @return array Format: array(array('value' => '<value>', 'label' => '<label>'), ...)
     */
    public function toOptionArray()
    {
        return [
        	['value' => Coupon::COUPON_FORMAT_ALPHANUMERIC, 'label' => __('Alphanumeric')],
            ['value' => Coupon::COUPON_FORMAT_ALPHABETICAL, 'label' => __('Alphabetical')],
            ['value' => Coupon::COUPON_FORMAT_NUMERIC, 'label' => __('Numeric')]
        ];
    }
}
