<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://www.mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category   Mageplaza
 * @package    Mageplaza_PdfInvoice
 * @copyright   Copyright (c) 2017-2018 Mageplaza (http://www.mageplaza.com/)
 * @license     https://www.mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\PdfInvoice\Setup;

use Magento\Framework\Setup\InstallDataInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Magento\Store\Model\StoreManagerInterface;
use Mageplaza\PdfInvoice\Helper\Data;

/**
 * Class InstallData
 * @package Mageplaza\PdfInvoice\Setup
 */
class InstallData implements InstallDataInterface
{
    /**
     * @var \Mageplaza\PdfInvoice\Helper\Data
     */
    protected $helperConfig;

    /**
     * @var \Magento\Store\Api\Data\StoreInterface
     */
    protected $storeManager;

    /**
     * InstallData constructor.
     * @param \Mageplaza\PdfInvoice\Helper\Data $helperConfig
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     */
    public function __construct(
        Data $helperConfig,
        StoreManagerInterface $storeManager
    )
    {
        $this->storeManager = $storeManager;
        $this->helperConfig = $helperConfig;
    }

    /**
     * @param \Magento\Framework\Setup\ModuleDataSetupInterface $setup
     * @param \Magento\Framework\Setup\ModuleContextInterface $context
     */
    public function install(ModuleDataSetupInterface $setup, ModuleContextInterface $context)
    {
        $this->helperConfig->setBusinessInformation();
    }
}