<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_ReviewBooster
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\ReviewBooster\Block\Adminhtml\Grid\Column\Renderer;

/**
 * Class Action
 * @package Mageplaza\ReviewBooster\Block\Adminhtml\Grid\Column\Renderer
 */
class Action extends \Magento\Backend\Block\Widget\Grid\Column\Renderer\Action
{
    /**
     * @param \Magento\Framework\DataObject $row
     * @return string
     */
    public function render(\Magento\Framework\DataObject $row)
    {
        $actions = [];

        $actions = [
                        [
                            'url' => $this->getUrl('reviewbooster/*/preview', ['id' => $row->getId()]),
                            'popup' => true,
                            'caption' => __('Preview')
                        ],
                        [
                            'url' => $this->getUrl('reviewbooster/*/delete', ['id' => $row->getId()]),
                            'caption' => __('Delete')
                        ],
                        [
                            'url' => $this->getUrl('reviewbooster/*/sentnow', ['id' => $row->getId()]),
                            'caption' => __('Send Now')
                        ]
                    ];

        $this->getColumn()->setActions($actions);

        return parent::render($row);
    }
}
