<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_ReviewBooster
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\ReviewBooster\Block\Adminhtml\Grid\Column\Renderer;

/**
 * Class Status
 * @package Mageplaza\ReviewBooster\Block\Adminhtml\Grid\Column\Renderer
 */
class Status extends \Magento\Backend\Block\Widget\Grid\Column\Renderer\AbstractRenderer
{
    /**
     * Render email status
     *
     * @param \Magento\Framework\DataObject $row
     * @return string
     */
    public function render(\Magento\Framework\DataObject $row)
    {
        $class = '';
        $text = '';
        if ($this->_getValue($row) == 1) {
            $class = 'grid-severity-notice';
            $text = __('Sent');
        } else if ($this->_getValue($row) == 3) {
            $text = __('Pending');
        } else {
            $class = 'grid-severity-major';
            $text = __('Error');
        }
        return '<span class="' . $class . '"><span>' . $text . '</span></span>';
    }
}
