<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_ReviewBooster
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\ReviewBooster\Block\Adminhtml;

/**
 * Class Logs
 * @package Mageplaza\ReviewBooster\Block\Adminhtml
 */
class Logs extends \Magento\Backend\Block\Widget\Grid\Container
{
    /**
     * constructor
     *
     * @return void
     */
    protected function _construct()
    {
        parent::_construct();
        $this->removeButton('add');
        $this->addButton(
            'clear',
            [
                'label' => __('Clear Logs'),
                'onclick' => 'confirmSetLocation(\'' . __(
                        'Are you sure you want to clear all logs?'
                    ) . '\', \'' . $this->getUrl('reviewbooster/index/clear') . '\')',
                'class' => 'clear primary'
            ]
        );
    }
}
