<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_ReviewBooster
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\ReviewBooster\Block\Review;

/**
 * Class Js
 * @package Mageplaza\ReviewBooster\Block\Review
 */
class Js extends \Magento\Framework\View\Element\Template
{
    /**
     * @var \Mageplaza\ReviewBooster\Helper\Data
     */
    private $reviewBoosterData;

    /**
     * Constructor
     *
     * @param \Magento\Framework\View\Element\Template\Context $context
     * @param \Mageplaza\ReviewBooster\Helper\Data $reviewBoosterData
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\View\Element\Template\Context $context,
        \Mageplaza\ReviewBooster\Helper\Data $reviewBoosterData,
        array $data = []
    ) {
        $this->reviewBoosterData = $reviewBoosterData;
        parent::__construct($context, $data);
    }

    /**
     * @return bool
     */
    public function isDisplay()
    {
        if ($this->reviewBoosterData->isEnabled() && $this->getRequest()->getParam('rb')) {
            return true;
        }
        return false;
    }
}
