<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_ReviewBooster
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\ReviewBooster\Controller\Adminhtml\Index;

/**
 * Class SentNow
 * @package Mageplaza\ReviewBooster\Controller\Adminhtml\Index
 */
class SentNow extends \Mageplaza\ReviewBooster\Controller\Adminhtml\ReviewBooster
{
	/**
     * Sent now action
     *
     * @return void
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        if ($id) {
            $log = $this->logsFactory->create()->load($id);
            if ($log->getId()) {
                try {
                    $this->reviewBoosterModel->sendMailNow($log);
                    $this->messageManager->addSuccess(__('Success.'));
                } catch (\Exception $e) {
                    $this->logger->critical($e);
                    $this->messageManager->addError(__('Error.'));
                }
            }
        }
        $this->_redirect('reviewbooster/*/logs');
    }
}
