<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_ReviewBooster
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\ReviewBooster\Cron;

/**
 * Class SendEmail
 * @package Mageplaza\ReviewBooster\Cron
 */
class SendEmail
{
    /**
     * @var \Psr\Log\LoggerInterface
     */
    private $logger;

    /**
     * @var \Mageplaza\ReviewBooster\Model\ReviewBooster
     */
    private $reviewBoosterModel;

    /**
     * @var \Mageplaza\ReviewBooster\Helper\Data
     */
    private $helperData;

    /**
     * Constructor
     *
     * @param \Psr\Log\LoggerInterface $logger
     * @param \Mageplaza\ReviewBooster\Model\ReviewBooster $reviewBoosterModel
     * @param \Mageplaza\ReviewBooster\Helper\Data $helperData
     */
    public function __construct(
        \Psr\Log\LoggerInterface $logger,
        \Mageplaza\ReviewBooster\Model\ReviewBooster $reviewBoosterModel,
        \Mageplaza\ReviewBooster\Helper\Data $helperData
    ) {
        $this->logger = $logger;
        $this->reviewBoosterModel = $reviewBoosterModel;
        $this->helperData = $helperData;
    }

    /**
     * @return void
     */
    public function execute()
    {
        if ($this->helperData->isEnabled()) {
            try {
                $this->reviewBoosterModel->sendMailCron();
            } catch (\Exception $e) {
                $this->logger->critical($e);
            }
        }
    }
}
