<?php
/**
 * Mageplaza
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the mageplaza.com license that is
 * available through the world-wide-web at this URL:
 * https://mageplaza.com/LICENSE.txt
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to newer
 * version in the future.
 *
 * @category    Mageplaza
 * @package     Mageplaza_ReviewBooster
 * @copyright   Copyright (c) 2017 Mageplaza (https://www.mageplaza.com/)
 * @license     http://mageplaza.com/LICENSE.txt
 */

namespace Mageplaza\ReviewBooster\Model;

/**
 * Class Logs
 * @package Mageplaza\ReviewBooster\Model
 */
class Logs extends \Magento\Framework\Model\AbstractModel
{
    /**
     * @return void
     */
    public function _construct()
    {
        parent::_construct();
        $this->_init('Mageplaza\ReviewBooster\Model\ResourceModel\Logs');
    }

    /**
     * @param array $config
     * @param string $customerEmail
     * @param string $customerName
     * @param string $body
     * @param string $subject
     * @param string $configId
     * @param \Magento\Sales\Model\Order\Item $orderItem
     * @param bool $status
     * @return $this
     */
    public function saveLogs(
        $config,
        $order,
        $body,
        $subject,
        $sequence,
        $scheduled,
        $customerName
    ) {
        $this->setSubject($subject)
            ->setCustomerEmail($order->getCustomerEmail())
            ->setSender($config['sender'])
            ->setCustomerName($customerName)
            ->setEmailContent(htmlspecialchars($body))
            ->setOrderId($order->getId())
            ->setSequenceNumber($sequence)
            ->setSendAt($scheduled)
            ->setStatus(3)
            ->save();
    }

    /**
     * @param string $fromDate
     * @param string $toDate
     * @param string $dimension
     * @return $this
     */
    public function loadReportData($fromDate, $toDate, $dimension)
    {
        return $this->_getResource()->loadReportData($fromDate, $toDate, $dimension);
    }

    /**
     *
     * @return mixed
     */
    public function clear()
    {
        return $this->_getResource()->clear();
    }
}
