<?php
/**
 * Copyright © 2017 Mageside. All rights reserved.
 * See MS-LICENSE.txt for license details.
 */

namespace Mageside\BackupToDropbox\Block\Adminhtml\System\Config\Field;

class IgnoreDbTable extends \Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray
{
    /**
     * Prepare to render
     *
     * @return void
     */
    protected function _prepareToRender()
    {
        $this->addColumn('table_ignore_list', ['label' => __('Ignore content of Table')]);
        $this->_addAfter = false;
        $value = $this->getElement()->getValue();
        if (!empty($value) && is_string($value)) {
            $value = json_decode($value, true);
            if (json_last_error() !== JSON_ERROR_NONE) {
                $value = [];
            }
            $value = $this->encodeArrayFieldValue($value);
            $this->getElement()->setValue($value);
        }
        $this->_addButtonLabel = __('Add New');
    }

    /**
     * @param array $value
     * @return array
     */
    protected function encodeArrayFieldValue(array $value)
    {
        $result = [];
        foreach ($value as $list => $itemList) {
            foreach ($itemList as $item) {
                $result[] = [$list => $item];
            }
        }
        return $result;
    }
}
