<?php
/**
 * Copyright © 2017 Mageside. All rights reserved.
 * See MS-LICENSE.txt for license details.
 */

namespace Mageside\BackupToDropbox\Plugin\Db;

class BackupDb
{
    /**
     * @var \Mageside\BackupToDropbox\Helper\Backup
     */
    protected $helper;

    /**
     * BackupDb constructor.
     * @param \Mageside\BackupToDropbox\Helper\Backup $helper
     */
    public function __construct(
        \Mageside\BackupToDropbox\Helper\Backup $helper
    ) {
        $this->helper = $helper;
    }

    /**
     * @param \Magento\Framework\Backup\Db\BackupFactory $subject
     * @param \Mageside\BackupToDropbox\Model\Db $result
     * @return mixed
     */
    public function afterCreateBackupDbModel(\Magento\Framework\Backup\Db\BackupFactory $subject, $result)
    {
        $tableList = $this->helper->getIgnoreTableList();
        if (!empty($tableList)) {
            $result->addIgnoreDataTablesList($tableList);
        }

        return $result;
    }
}
