<?php

namespace Natz\AccountVerify\Block;


class VerForm extends \Magento\Framework\View\Element\Template
{

    public $helper;

    protected $_session;

    protected $_verProcess;

    public function __construct(
         \Magento\Framework\View\Element\Template\Context $context,
         \Natz\AccountVerify\Helper\Data $helper,
         \Magento\Customer\Model\Session $session,
         \Natz\AccountVerify\Model\VerificationProcess $verProcess,
         array $layoutProcessors = [],
         array $data = []
    )
    {
        $this->helper = $helper;
        parent::__construct($context, $data);
        $this->jsLayout = isset($data['jsLayout']) && is_array($data['jsLayout']) ? $data['jsLayout'] : [];
       $this->layoutProcessors = $layoutProcessors;
       $this->_session = $session;
       $this->_verProcess = $verProcess;
    }

    public function getJsLayout()
     {
         foreach ($this->layoutProcessors as $processor) {
             $this->jsLayout = $processor->process($this->jsLayout);
         }
         return \Zend_Json::encode($this->jsLayout);
     }

   public function getCustomerLoggedIn()
    {
        if ($this->_session->isLoggedIn()) 
            return 1;
        else
            return 0;
    }


}