<?php
namespace Natz\AccountVerify\Model;


class VerificationProcess
{
    protected $_sms;

    protected $_helper;

    protected $date;

    protected $_resource;

    protected $_verProcess;

    protected $emailProcess;

    protected $_countryCode;

    protected $_messageParser;

    public function __construct(
        \Natz\AccountVerify\Model\Smslogs $sms,
        \Natz\AccountVerify\Helper\Data $helper,
        \Magento\Framework\Stdlib\DateTime\DateTime $date,
        \Magento\Framework\App\ResourceConnection $resource,
        \Natz\AccountVerify\Model\SmsSend $verProcess,
        \Natz\AccountVerify\Model\EmailProcess $emailProcess,
        \Natz\AccountVerify\Helper\CountryCode $country_code,
        \Natz\AccountVerify\Helper\MessageTemplateParser $messageParser
    ) {
        $this->_sms = $sms;
        $this->_helper = $helper;
        $this->date = $date;
        $this->_resource = $resource;
        $this->_verProcess = $verProcess;
        $this->emailProcess = $emailProcess;
        $this->_countryCode = $country_code;
        $this->_messageParser = $messageParser;
        
    }

    public function saveVerificationCode($data) {

        $cname = $data['firstname']." ".$data['lastname'];
        $mobilenumber = $data['mobile_number'];
        $ver_email = $data['email'];
        
        $status = $data['status'];
        $currentDate = $this->date->gmtDate();
        $connection = $this->_resource->getConnection();
        $country_id = $data['country_id'];
        $data['countrycode']=$country_id;

        $validationResponse = $this->validateAccount($data);

        if (count($validationResponse)==1){
            $vercode =  $validationResponse[0]['ver_code'];
        }else{
            $vercode =  $this->_helper->getRandomString();
        }

        $emailInfo = array();
        $emailInfo['name'] = $cname;
        $emailInfo['email'] = $ver_email;
        $emailInfo['mobileno'] = $mobilenumber;
        $emailInfo['code'] = $vercode;

        $response = $this->_verProcess->sendVerificationCode($vercode,$mobilenumber,$country_id);

        $smsGateway = $this->_helper->getSMSGateway();
        if ($smsGateway =='b2bsms') {
            if ($response[0] == 'OK') {
                $sql = "INSERT INTO " . $this->_resource->getTableName('natz_accountverify_smslogs') .
                    "(ver_name,ver_email, mobile_number, ver_code, sent_date, ver_status)
                 VALUES ('" . $cname . "','" . $ver_email . "', '" . $response[1] . "','" . $vercode . "','" . $currentDate . "','" . $status . "')
                 ON DUPLICATE KEY UPDATE 
                        ver_name = VALUES(ver_name), 
                        ver_email = VALUES(ver_email), 
                        mobile_number = VALUES(mobile_number), 
                        ver_code = VALUES(ver_code),  
                        sent_date = VALUES(sent_date), 
                        ver_status = VALUES(ver_status)";
                $connection->query($sql);


                if ($this->_helper->getActiveIsAdminEmail()) {
                    $this->emailProcess->sendEmailToAdmin($emailInfo);
                }

                if ($this->_helper->getIsActiveCustomerEmail()) {
                    $this->emailProcess->sendEmailToCustomer($emailInfo);
                }

                return 1;
            } else {
                return 0;
            }
        } else if ($smsGateway == 'twilio') {
            if($response->errorCode != null or $response->errorMessage != null) {
                return 0;
            } else {
                $sql = "INSERT INTO " . $this->_resource->getTableName('natz_accountverify_smslogs') .
                    "(ver_name,ver_email, mobile_number, ver_code, sent_date, ver_status)
                 VALUES ('" . $cname . "','" . $ver_email . "', '" . $mobilenumber . "','" . $vercode . "','" . $currentDate . "','" . $status . "')
                 ON DUPLICATE KEY UPDATE 
                        ver_name = VALUES(ver_name), 
                        ver_email = VALUES(ver_email), 
                        mobile_number = VALUES(mobile_number), 
                        ver_code = VALUES(ver_code),  
                        sent_date = VALUES(sent_date), 
                        ver_status = VALUES(ver_status)";
                $connection->query($sql);


                if ($this->_helper->getActiveIsAdminEmail()) {
                    $this->emailProcess->sendEmailToAdmin($emailInfo);
                }

                if ($this->_helper->getIsActiveCustomerEmail()) {
                    $this->emailProcess->sendEmailToCustomer($emailInfo);
                }

                return 1;
            }
        } else if ($smsGateway == 'nexmo') {
            if ($response['status'] == 0) {
                $sql = "INSERT INTO " . $this->_resource->getTableName('natz_accountverify_smslogs') .
                    "(ver_name,ver_email, mobile_number, ver_code, sent_date, ver_status)
                 VALUES ('" . $cname . "','" . $ver_email . "', '" . $response['to'] . "','" . $vercode . "','" . $currentDate . "','" . $status . "')
                 ON DUPLICATE KEY UPDATE 
                        ver_name = VALUES(ver_name), 
                        ver_email = VALUES(ver_email), 
                        mobile_number = VALUES(mobile_number), 
                        ver_code = VALUES(ver_code),  
                        sent_date = VALUES(sent_date), 
                        ver_status = VALUES(ver_status)";
                $connection->query($sql);


                if ($this->_helper->getActiveIsAdminEmail()) {
                    $this->emailProcess->sendEmailToAdmin($emailInfo);
                }

                if ($this->_helper->getIsActiveCustomerEmail()) {
                    $this->emailProcess->sendEmailToCustomer($emailInfo);
                }

                return 1;
            } else {
                return 0;
            }
        }

    }


    public function verifyRecord($data)
    {   
        $mb = $data['mobile_number'];
        $ver_email = $data['email'];
        $vercode =  $data['ver_code'];
        $countryCode = $data['countrycode'];

        $areacode = $this->_countryCode->getCountryCallingCode($countryCode);
        $mobilenumber = $mb;//$this->_messageParser->updateCountryCode($areacode,$mb,10);

        $connection = $this->_resource->getConnection();
        $sql = "SELECT smslogs_id,mobile_number, ver_code, ver_email FROM ".$this->_resource->getTableName('natz_accountverify_smslogs').
               " WHERE mobile_number = '".$mobilenumber."' AND ver_email = '".$ver_email."' AND ver_code = '".$vercode."'
                 LIMIT 1 "; 
        $response= $connection->fetchOne($sql);

        if ($response){
            $this->updateSmsLogStatus($response);
            return true;
        }else{
             return false;
        }   
               
    }

    public function validateAccount($data)
    {   
        $mb = $data['mobile_number'];
        $ver_email = $data['email'];
        $countryCode = $data['countrycode'];

        $areacode = $this->_countryCode->getCountryCallingCode($countryCode);
        $mobilenumber = $mb;//$this->_messageParser->updateCountryCode($areacode,$mb,10);
        $table =$this->_resource->getTableName('natz_accountverify_smslogs');

        $connection = $this->_resource->getConnection();
        $sql = "SELECT * FROM $table WHERE mobile_number = '$mobilenumber' AND ver_email = '$ver_email' LIMIT 1 ";
        $response= $connection->fetchAll($sql);
        return $response;
                   
    }

    private function updateSmsLogStatus($id)
    {   
        $connection = $this->_resource->getConnection();
        $currentDate = $this->date->gmtDate();
        $sql =  "UPDATE ".$this->_resource->getTableName('natz_accountverify_smslogs').
                " SET ver_status='Confirmed',date_verified='".$currentDate."'
                 WHERE smslogs_id=$id";
        $connection->query($sql);

    }

    public function getMobileNumberIfNotExist($emailadd)
    {   

        $connection = $this->_resource->getConnection();
        $table =$this->_resource->getTableName('natz_accountverify_smslogs');
        $sql = "SELECT * FROM $table WHERE ver_email = '$emailadd' ORDER BY smslogs_id DESC LIMIT 1 "; 
        $response= $connection->fetchAll($sql);
        return $response;
                   
    }

}