<?php

namespace Potato\PerformanceMonitoring\Api;

/**
 * @api
 */
interface TransactionSystemRepositoryInterface
{
    /**
     * Create TransactionSystem service
     *
     * @param \Potato\PerformanceMonitoring\Api\Data\TransactionSystemInterface $transactionSystem
     * @return \Potato\PerformanceMonitoring\Api\Data\TransactionSystemInterface
     * @throws \Magento\Framework\Exception\CouldNotSaveException
     */
    public function save(Data\TransactionSystemInterface $transactionSystem);

    /**
     * Get info about TransactionSystem by transactionSystem id
     *
     * @param int $transactionSystemId
     * @return \Potato\PerformanceMonitoring\Api\Data\TransactionSystemInterface
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function get($transactionSystemId);

    /**
     * Delete transactionSystem
     *
     * @param \Potato\PerformanceMonitoring\Api\Data\TransactionSystemInterface $transactionSystem
     * @return void
     * @throws \Magento\Framework\Exception\InputException
     * @throws \Magento\Framework\Exception\StateException
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function delete(Data\TransactionSystemInterface $transactionSystem);

    /**
     * @param string $date
     * @return $this
     */
    public function removeDataByDate($date);

    /**
     * Create new empty transaction system model
     * @return \Potato\PerformanceMonitoring\Api\Data\TransactionSystemInterface
     */
    public function create();
}
