<?php
namespace Potato\PerformanceMonitoring\Block\Adminhtml\Form;

use Potato\PerformanceMonitoring\Model\Chart;
use Magento\Backend\Block\Widget;
use Magento\Backend\Block\Template\Context;

/**
 * Class Edit
 */
class Edit extends Widget
{
    protected $_template = 'Potato_PerformanceMonitoring::container.phtml';

    /** @var Chart  */
    protected $chart;

    /**
     * Edit constructor.
     * @param Context $context
     * @param Chart $chart
     * @param array $data
     */
    public function __construct(
        Context $context,
        Chart $chart,
        array $data = []
    ) {
        parent::__construct($context, $data);
        $this->chart = $chart;
    }

    /**
     * @return string
     */
    public function getDateFrom()
    {
        return $this->chart->getDateFrom();
    }

    /**
     * @return string
     */
    public function getDateTo()
    {
        return $this->chart->getDateTo();
    }
}
