<?php

namespace Potato\PerformanceMonitoring\Model\Data;

use Magento\Framework\Api\AbstractExtensibleObject;
use Potato\PerformanceMonitoring\Api\Data\CpuInterface;

/**
 * Class Cpu
 */
class Cpu extends AbstractExtensibleObject implements CpuInterface
{
    /**
     * @return int|null
     */
    public function getId()
    {
        return $this->_get(self::ID);
    }

    /**
     * @param int|null $id
     * @return $this
     */
    public function setId($id)
    {
        return $this->setData(self::ID, $id);
    }
    
    /**
     * @return float|null
     */
    public function getValue()
    {
        return $this->_get(self::VALUE);
    }

    /**
     * @param float|null $value
     * @return $this
     */
    public function setValue($value)
    {
        return $this->setData(self::VALUE, $value);
    }
    
    /**
     * @return string|null
     */
    public function getCreatedAt()
    {
        return $this->_get(self::CREATED_AT);
    }

    /**
     * @param string|null $createdAt
     * @return $this
     */
    public function setCreatedAt($createdAt)
    {
        return $this->setData(self::CREATED_AT, $createdAt);
    }
    
    /**
     * @api
     * @return array
     */
    public function toArray()
    {
        return $this->__toArray();
    }
}
