<?php

namespace Potato\PerformanceMonitoring\Model\Data;

use Magento\Framework\Api\AbstractExtensibleObject;
use Potato\PerformanceMonitoring\Api\Data\TransactionSystemInterface;

/**
 * Class TransactionSystem
 */
class TransactionSystem extends AbstractExtensibleObject implements TransactionSystemInterface
{
    /**
     * @return int|null
     */
    public function getId()
    {
        return $this->_get(self::ID);
    }

    /**
     * @param int|null $id
     * @return $this
     */
    public function setId($id)
    {
        return $this->setData(self::ID, $id);
    }
    
    /**
     * @return float|null
     */
    public function getCpu()
    {
        return $this->_get(self::CPU);
    }

    /**
     * @param float|null $cpu
     * @return $this
     */
    public function setCpu($cpu)
    {
        return $this->setData(self::CPU, $cpu);
    }
    
    /**
     * @return float|null
     */
    public function getMemory()
    {
        return $this->_get(self::MEMORY);
    }

    /**
     * @param float|null $memory
     * @return $this
     */
    public function setMemory($memory)
    {
        return $this->setData(self::MEMORY, $memory);
    }
    
    /**
     * @return string|null
     */
    public function getCmd()
    {
        return $this->_get(self::CMD);
    }

    /**
     * @param string|null $cmd
     * @return $this
     */
    public function setCmd($cmd)
    {
        return $this->setData(self::CMD, $cmd);
    }
    
    /**
     * @return string|null
     */
    public function getProcesses()
    {
        return $this->_get(self::PROCESSES);
    }

    /**
     * @param string|null $processes
     * @return $this
     */
    public function setProcesses($processes)
    {
        return $this->setData(self::PROCESSES, $processes);
    }
    
    /**
     * @return string
     */
    public function getCreatedAt()
    {
        return $this->_get(self::CREATED_AT);
    }

    /**
     * @param string $createdAt
     * @return $this
     */
    public function setCreatedAt($createdAt)
    {
        return $this->setData(self::CREATED_AT, $createdAt);
    }
    
    /**
     * @api
     * @return array
     */
    public function toArray()
    {
        return $this->__toArray();
    }
}
