<?php

namespace Potato\PerformanceMonitoring\Setup;

use Magento\Framework\Setup\InstallSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

/**
 * Class InstallSchema
 */
class InstallSchema implements InstallSchemaInterface
{
    /**
     * {@inheritdoc}
     * @SuppressWarnings(PHPMD.ExcessiveMethodLength)
     * @throws \Zend_Db_Exception
     */
    public function install(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        
        $table = $installer->getConnection()->newTable($installer->getTable('po_monitoring_cpu'))
            ->addColumn(
                'id',
                \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                null,
                ['unsigned' => true, 'primary' => true, 'identity' => true, 'nullable' => false]
            )
            ->addColumn(
                'value',
                \Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
                null,
                ['default' => '0.00']
            )
            ->addColumn(
                'created_at',
                \Magento\Framework\DB\Ddl\Table::TYPE_DATETIME,
                null,
                []
            );
        
        $installer->getConnection()->createTable($table);

        $table = $installer->getConnection()->newTable($installer->getTable('po_monitoring_memory'))
            ->addColumn(
                'id',
                \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                null,
                ['unsigned' => true, 'primary' => true, 'identity' => true, 'nullable' => false]
            )
            ->addColumn(
                'value',
                \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                null,
                ['unsigned' => true]
            )
            ->addColumn(
                'swap',
                \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                null,
                ['unsigned' => true]
            )
            ->addColumn(
                'created_at',
                \Magento\Framework\DB\Ddl\Table::TYPE_DATETIME,
                null,
                []
            );
        $installer->getConnection()->createTable($table);

        $table = $installer->getConnection()->newTable($installer->getTable('po_monitoring_transaction_system'))
            ->addColumn(
                'id',
                \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                null,
                ['unsigned' => true, 'primary' => true, 'identity' => true, 'nullable' => false]
            )
            ->addColumn(
                'cpu',
                \Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
                null,
                ['default' => '0.00']
            )
            ->addColumn(
                'memory',
                \Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
                null,
                ['default' => '0.00']
            )
            ->addColumn(
                'cmd',
                \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                255,
                []
            )
            ->addColumn(
                'processes',
                \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                null,
                []
            )
            ->addColumn(
                'created_at',
                \Magento\Framework\DB\Ddl\Table::TYPE_DATETIME,
                null,
                []
            );
        $installer->getConnection()->createTable($table);

        $table = $installer->getConnection()->newTable($installer->getTable('po_monitoring_transaction_web'))
            ->addColumn(
                'id',
                \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                null,
                ['unsigned' => true, 'primary' => true, 'identity' => true, 'nullable' => false]
            )
            ->addColumn(
                'pid',
                \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                255,
                []
            )
            ->addColumn(
                'cpu',
                \Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
                null,
                ['default' => '0.00']
            )
            ->addColumn(
                'memory',
                \Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
                null,
                ['default' => '0.00']
            )
            ->addColumn(
                'url',
                \Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
                255,
                []
            )
            ->addColumn(
                'time',
                \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
                null,
                ['unsigned' => 1]
            )
            ->addColumn(
                'created_at',
                \Magento\Framework\DB\Ddl\Table::TYPE_DATETIME,
                null,
                []
            );
        $installer->getConnection()->createTable($table);
        $installer->endSetup();
    }
}
