<?php

namespace Sapienttree\Luckydraw\Block;

class Winner extends \Magento\Framework\View\Element\Template {

    protected $_scopeConfig;
    protected $_objectManager;

    public function __construct(\Magento\Framework\View\Element\Template\Context $context, \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig) {
        $this->_scopeConfig = $scopeConfig;
        parent::__construct($context);
        $this->_objectManager = \Magento\Framework\App\ObjectManager::getInstance();
    }

    public function getPromotionName() {
        $name = $this->_scopeConfig->getValue('luckydraw/general/name', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
        return $name;
    }

    public function getPromotionStartDate() {
        $start_date = $this->_scopeConfig->getValue('luckydraw/general/start_date', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
        return $start_date;
    }

    public function getPromotionEndDate() {
        $end_date = $this->_scopeConfig->getValue('luckydraw/general/end_date', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);
        return $end_date;
    }

    public function getWinner() {
        $luckydrawCollection = $this->_objectManager->create('\Sapienttree\Luckydraw\Model\ResourceModel\Luckydraw\Collection');
        $luckydrawCollection->addFieldToFilter('is_winner', array('eq' => 1));

        $start_date = $this->getPromotionStartDate();
        $end_date = $this->getPromotionEndDate();
        if ($start_date && $end_date) {
            $luckydrawCollection->addFieldToFilter('created_at', array('gt' => $start_date));
            $luckydrawCollection->addFieldToFilter('created_at', array('lt' => $end_date));
        } elseif ($start_date && !$end_date) {
            $luckydrawCollection->addFieldToFilter('created_at', array('gt' => $start_date));
        } elseif (!$start_date && $end_date) {
            $luckydrawCollection->addFieldToFilter('created_at', array('lt' => $end_date));
        }
        $luckydrawCollection->getSelect()->limit(1);
        return $luckydrawCollection;
    }

    public function getActiveContest() {
        $luckydrawCollection = $this->_objectManager->create('\Sapienttree\Luckydraw\Model\ResourceModel\Luckydraw\Collection');
        //$luckydrawCollection->addFieldToFilter('is_winner', array('neq' => 1));

        $start_date = $this->getPromotionStartDate();
        $end_date = $this->getPromotionEndDate();
        if ($start_date && $end_date) {
            $luckydrawCollection->addFieldToFilter('created_at', array('gt' => $start_date));
            $luckydrawCollection->addFieldToFilter('created_at', array('lt' => $end_date));
        } elseif ($start_date && !$end_date) {
            $luckydrawCollection->addFieldToFilter('created_at', array('gt' => $start_date));
        } elseif (!$start_date && $end_date) {
            $luckydrawCollection->addFieldToFilter('created_at', array('lt' => $end_date));
        }
        //$luckydrawCollection->getSelect()->limit(1);
        return $luckydrawCollection;
    }

    public function getLuckyWinnwerUrl() {
        $url = $this->getUrl('luckydraw/winner/index');
        return $url;
    }
    
    public function getLuckyWinnwerConfirmUrl() {
        $url = $this->getUrl('luckydraw/winner/confirm');
        return $url;
    }

}
