<?php

namespace Sapienttree\Luckydraw\Model;

use Sapienttree\Luckydraw\Api\Data\GridInterface;

class Grid extends \Magento\Framework\Model\AbstractModel implements GridInterface {

    /**
     * CMS page cache tag.
     */
    const CACHE_TAG = 'sptr_luckydraw_records';

    /**
     * @var string
     */
    protected $_cacheTag = 'sptr_luckydraw_records';

    /**
     * Prefix of model events names.
     *
     * @var string
     */
    protected $_eventPrefix = 'sptr_luckydraw_records';

    /**
     * Initialize resource model.
     */
    protected function _construct() {
        $this->_init('Sapienttree\Luckydraw\Model\ResourceModel\Grid');
    }

    /**
     * Get EntityId.
     *
     * @return int
     */
    public function getEntityId() {
        return $this->getData(self::ENTITY_ID);
    }

    /**
     * Set EntityId.
     */
    public function setEntityId($entityId) {
        return $this->setData(self::ENTITY_ID, $entityId);
    }

    /**
     * Get CreatedAt.
     *
     * @return varchar
     */
    public function getCreatedAt() {
        return $this->getData(self::CREATED_AT);
    }

    /**
     * Set CreatedAt.
     */
    public function setCreatedAt($createdAt) {
        return $this->setData(self::CREATED_AT, $createdAt);
    }

}
