<?php

namespace Sapienttree\Luckydraw\Setup;

class InstallSchema implements \Magento\Framework\Setup\InstallSchemaInterface {

    public function install(\Magento\Framework\Setup\SchemaSetupInterface $setup, \Magento\Framework\Setup\ModuleContextInterface $context) {
        $installer = $setup;
        $installer->startSetup();
        if (!$installer->tableExists('sapienttree_luckydraw')) {
            $table = $installer->getConnection()->newTable(
                            $installer->getTable('sapienttree_luckydraw')
                    )
                    ->addColumn(
                            'lucky_draw_id', \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER, null, [
                        'identity' => true,
                        'nullable' => false,
                        'primary' => true,
                        'unsigned' => true,
                            ], 'Luckydraw ID'  
                    )
                    ->addColumn(
                            'contest_name', \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 255, ['nullable' => false], 'Contest Name'
                    )
                    ->addColumn(
                            'customer_id', \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER, null, ['nullable' => true], 'Customer Id'
                    )
                    ->addColumn(
                            'customer_name', \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 255, ['nullable' => false], 'Customer Name'
                    )
                    ->addColumn(
                            'customer_email', \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 255, ['nullable' => true], 'Customer Email'
                    )
                    ->addColumn(
                            'customer_phone', \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 255, ['nullable' => true], 'Customer Phone Number'
                    )
                    ->addColumn(
                            'order_id', \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 255, ['nullable' => false], 'Order Id'
                    )
                    ->addColumn(
                            'order_number', \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 255, ['nullable' => false], 'Order Number'
                    )
                    ->addColumn(
                            'order_total', \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 255, ['nullable' => false], 'Order Total'
                    )
                    ->addColumn(
                            'ticket', \Magento\Framework\DB\Ddl\Table::TYPE_TEXT, 255, ['nullable' => false], 'Ticket'
                    )
                    ->addColumn(
                            'is_winner', \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER, 1, ['nullable' => true], 'Is Winner'
                    )
                    ->addColumn(
                            'prize_awarded', \Magento\Framework\DB\Ddl\Table::TYPE_INTEGER, 1, ['nullable' => true], 'Winner Recieved The Prize'
                    )
                    ->addColumn(
                            'prize_anounced_date', \Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP, null, ['nullable' => true], 'Prize Announced Date'
                    )
                    ->addColumn(
                            'prize_awarded_date', \Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP, null, ['nullable' => true], 'Prize Awarded Date'
                    )
                    ->addColumn(
                            'created_at', \Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP, null, ['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT], 'Created At'
                    )->addColumn(
                            'updated_at', \Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP, null, ['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT_UPDATE], 'Updated At')
                    ->setComment('Luckydraw Table');
            $installer->getConnection()->createTable($table);

            $installer->getConnection()->addIndex(
                    $installer->getTable('sapienttree_luckydraw'), $setup->getIdxName(
                            $installer->getTable('sapienttree_luckydraw'), ['contest_name','customer_email', 'order_number', 'order_total', 'ticket'], \Magento\Framework\DB\Adapter\AdapterInterface::INDEX_TYPE_FULLTEXT
                    ), ['contest_name','customer_email', 'order_number', 'order_total', 'ticket'], \Magento\Framework\DB\Adapter\AdapterInterface::INDEX_TYPE_FULLTEXT
            );
        }
        $installer->endSetup();
    }

}
