<?php

namespace Themecafe\CODOrderVerification\Controller\Frontend;

class OtpVerify extends \Magento\Framework\App\Action\Action {
    public $timeLimit = 5 * 60;//5 minutes difference

    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Magento\Checkout\Model\Session $_checkoutSession,
        \Magento\Framework\App\ResourceConnection $resourceConnection,
        \Themecafe\CODOrderVerification\Model\OtpVerificationFactory $otpVerificationFactory,
        \Magento\Framework\Stdlib\DateTime\DateTime $DateTime,
        \Themecafe\CODOrderVerification\Helper\Data $helper
    ) {
        $this->resultJsonFactory = $resultJsonFactory;
        $this->resultPageFactory = $resultPageFactory;
        $this->om = $context->getObjectManager();
        $this->_checkoutSession = $_checkoutSession;
        $this->_resources = $resourceConnection;
        $this->otpVerificationFactory = $otpVerificationFactory;
        $this->DateTime = $DateTime;
        $this->request = $context->getRequest();
        parent::__construct($context);
    }
    public function execute() {
        $otpvalue = $this->request->getParam('otpvalue');
        
        $quoteid = $this->_checkoutSession->getQuoteId();
        
        $currentTimestamp = $this->DateTime->timestamp();
        
        $contactnumber = $this->request->getParam('billingNumber');
        $return = $this->verifyOTP($quoteid, $otpvalue, $currentTimestamp, $contactnumber);
        
        $response['response'] = $return;
        $this->getResponse()->representJson(
            $this->om->get('Magento\Framework\Json\Helper\Data')->jsonEncode($response)
        );
        return ;
    }
    public function verifyOTP($quoteid, $otpvalue, $currentTimestamp, $contactnumber) {
        $Otpcollection = $this->otpVerificationFactory->create()->getCollection()->addFieldToFilter('quote_id', $quoteid);
        
        $quoteArray = $Otpcollection->getColumnValues('quote_id');
        
        if(in_array($quoteid, $quoteArray)) {
            $qdata = $Otpcollection->getData();
            $otpData="";
            $mobilenumber="";
            foreach($qdata as $data){
                $otpData = $data['otp_code'];
                $mobilenumber = $data['mobile_number'];
            }
            $timer = $data['send_time'] + $this->timeLimit;
            $otpModel = $this->otpVerificationFactory->create();
            $otpModel->load($quoteid, 'quote_id');
//            echo $currentTimestamp."<".$timer;
            if(($otpData == $otpvalue) && ($currentTimestamp < $timer) && ($mobilenumber == $contactnumber)){
                $otpModel->setData('verified', 1);
                $return = 1;
            }else {
                $otpModel->setData('verified', 0);
                $return = 0;
            }
            $otpModel->save();
            return $return;
        }
        return 0;
    }
}
