<?php
namespace Themecafe\CODOrderVerification\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\OfflinePayments\Model\Cashondelivery;
use Magento\OfflinePayments\Model\Checkmo;
use Magento\Framework\App\ObjectManager;
use \Magento\Checkout\Model\Session as CheckoutSession;
use Magento\Framework\DataObject;
use \Magento\Framework\Exception\LocalizedException;

class BeforeOrderPaymentSaveObserver implements ObserverInterface {

    public function __construct(
        CheckoutSession $checkoutSession,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Themecafe\CODOrderVerification\Helper\Data $helper
    ) {         
        $this->checkoutSession = $checkoutSession;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->helper = $helper;
    }

    public function execute(\Magento\Framework\Event\Observer $observer) {        
        if($this->helper->isActive($this->helper->getStoreId())){
            $payment = $observer->getEvent()->getPayment();
            if ($payment->getMethod() == "cashondelivery") {
                $objectManager = ObjectManager::getInstance();
                $Otpcollection = $objectManager->create('Themecafe\CODOrderVerification\Model\OtpVerificationFactory')->create()->getCollection();
                $quoteArray = $Otpcollection->getColumnValues('quote_id');

                $quoteId = $this->checkoutSession->getQuoteId();
                $quote = $this->checkoutSession->getQuote();
                $ShippingTelephone = $quote->getShippingAddress()->getTelephone();

                $OtpVerified = 0;
                $shippingMobileNumber = "";
                if (in_array($quoteId, $quoteArray)) {
                    $qdata = $Otpcollection->addFieldToFilter('quote_id', $quoteId)->getData();
                    foreach ($qdata as $data) {
                        $OtpVerified = $data['verified'];
                        $shippingMobileNumber = $data['mobile_number'];
                    }
                }
                if ($OtpVerified && ($ShippingTelephone == $shippingMobileNumber)) {
                    return true;
                }
                throw new LocalizedException(__($this->helper->placeOdrerErrorMessage()));
            }
        }
    }

}
