<?php
/**
 * A Magento 2 module named Vit/Stockupdate
 * Copyright (C) 2017
 *
 * This file included in Vit/Stockupdate is licensed under OSL 3.0
 *
 * http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 * Please see LICENSE.txt for the full text of the OSL 3.0 license
 */

namespace Vit\Stockupdate\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputOption;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class Stockupdate extends Command
{

    const NAME_ARGUMENT = "name";

    const NAME_OPTION = "o";

    private $itemData = null;

    private $soap = null;

    private $soapURL = 'http://58.27.236.238:901/services.asmx?wsdl';

    private $soapOptions = array('connection_timeout' => 6000);

    private $soapAllItemsErrors = 0;

    private $soapGetBarcodeDataErrors = 0;

    private $barcodeData = array();

    private $currentProduct = 0;

    private $countProducts = 0;
	protected $logger;

    /**
     *
     * {@inheritdoc}
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {

//        $name = $input->getArgument(self::NAME_ARGUMENT);
        $option = $input->getOption(self::NAME_OPTION);
//        $this->logConsole($option);

        //$output->writeln("Hello " . $name);
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        /** @var \Magento\Catalog\Model\ResourceModel\Product\Collection $productCollection */
        $productCollection = $objectManager->create('Magento\Catalog\Model\ResourceModel\Product\Collection');
        /**
         * Apply filters here
         */
        $eventManager = $objectManager->create('\Magento\Framework\Event\ManagerInterface');
        $productCollection->addAttributeToSelect('*');
//$productCollection->addAttributeToFilter('entity_id',['gt'=>6000]);
        //if ($option == '1') $productCollection->addAttributeToFilter('status',\Magento\Catalog\Model\Product\Attribute\Source\Status::STATUS_ENABLED);
//$productCollection->addAttributeToFilter('sku', array('eq' => '35-0001-000354'));
//$productCollection->addAttributeToFilter('barcode',['like'=>'%,%']);
$productCollection->addAttributeToFilter('updated_at', array('lt' => (new \DateTime())->modify('-1 hour')));
//$productCollection->setPageSize(10)->setCurPage(1);
        
		$productCollection->load();
echo $productCollection->getSelect();
        $this->countProducts = count($productCollection);
//        $this->logConsole($this->countProducts);
//die($this->countProducts);
        $this->currentProduct = 0;

		/*start disable product qty <1*/
		/*$disableproductCollection = $objectManager->create('Magento\Catalog\Model\ResourceModel\Product\Collection');
	
        $disableproductCollection->addAttributeToSelect('*');
		$disableproductCollection->addFieldTofilter('type_id','simple');

        //if ($option == '1') $productCollection->addAttributeToFilter('status',\Magento\Catalog\Model\Product\Attribute\Source\Status::STATUS_ENABLED);
		//$disableproductCollection->addAttributeToFilter('qty', array('lt' => 1));
		$disableproductCollection->joinField(
		'qty', 'cataloginventory_stock_item', 'qty', 'product_id=entity_id', '{{table}}.stock_id=1', 'left'
		);
		$disableproductCollection->addAttributeToFilter('qty',['lt'=>1]);
		//$productCollection->setPageSize(10)->setCurPage(1);
        //echo $disableproductCollection->getSelect();
		
		$collection = $disableproductCollection->load();
    	foreach ($collection as $value) {
			$productModel = $objectManager->get('\Magento\Catalog\Model\Product');
                    $refreshProduct = $productModel->load($value->getId());
					$refreshProduct->setStatus(2);
					$refreshProduct->save();
					//echo '-hi'.$value->getId();
		}
		ends disable product qty <1*/

        $this->getAllData();
//echo "<pre>";print_r($this->itemData);echo "</pre>";
        foreach ($productCollection as $product) {

            try {
                $sku = $product->getSku();
//                if ($sku <> '28-0004-000123') continue;

                $eventManager->dispatch('isp_catalog_product_save_after', ['product' => $product]);

                //$productData = $this->getProductData($sku);
				//echo "<pre>";print_r();echo "</pre>";
                /*if (!is_array($productData)) {
                    $this->logConsole('No product data from Service for SKU="' . $sku . '"', true, '0;31m');
//                    $this->currentProduct++;
//                    continue;
                }*/

                $barcodesString = $product->getBarcode();

                $barcodes = explode(",", $barcodesString);
                $barcodes = array_map('trim', $barcodes);
                $barcodes = array_fill_keys( array_values($barcodes), false);
//    if (count($barcodes) < 2) continue;

                $this->logConsole('SKU="' . $sku . '". Barcodes before: ' . $barcodesString);

               /* if (!is_array($productData)) {
                    if (isset($product['CHILDID'])) $barcodes[$product['CHILDID']] = false;
                }

                foreach ($barcodes as $k => $v)
                {
                    $tempItems = $this->getAllDataBarcd($k);
                    if (is_array($tempItems))
                    {
                        foreach ($tempItems as $item)
                        {
                            if (is_array($item))
                            {
                                $barcodes[$k] = $item;
                                if ( isset($item['ALTERNATEBARCODE']) AND !isset( $barcodes[$item['ALTERNATEBARCODE']] ) )
                                    $barcodes[$item['ALTERNATEBARCODE']] = $this->getAllDataBarcd($item['ALTERNATEBARCODE']);
                            }
                        }
                    }
                }*/

                $this->logConsole('SKU="' . $sku . '". Barcodes after: ' . implode( ',', array_keys($barcodes) ) );

                $maxRetailPrice = 0;
                $maxCostPrice = 0;
                $maxRetailPriceID = '';
				$stk = 0;
				$stt = 0;
				$enbl = 2;

               /* if (is_array($productData)) {
                    $maxRetailPrice = $productData['PRICE'];
                    $maxCostPrice = $productData['COST_PRICE'];
                    $maxRetailPriceID = $sku;
					$stk = $productData['QUANTITY'];
                }

                foreach ($barcodes as $k => $v)
                {
                    if (is_array($v))
                    {
                        if (isset($v['RETAILPRICE'])) {
                            $maxRetailPrice = max($maxRetailPrice, $v['RETAILPRICE']);
                            $maxRetailPriceID = $k;
							
                        }
                        if (isset($v['COSTPRICE'])) $maxCostPrice = max($maxCostPrice, $v['COSTPRICE']);
						if (isset($v['QUANTITY'])) $stk = $v['QUANTITY'];
						$this->logConsole('Stock Quantity is ='.$v['QUANTITY']);
						$this->logger->info('Stock Quantity is ='.$v['QUANTITY'].' for sku = '.$sku);
                    }
                }*/
//echo "<pre>";print_r($barcodes);echo "</pre>";
               /* if (!empty($maxRetailPrice))
                {*/
				$t = 0;
				$this->logConsole(++$t);
                    $this->logConsole('Stock Quantity and Stock Status Change Starts');
                    //$productModel = $objectManager->get('\Magento\Catalog\Model\Product');
                    //$refreshProduct = $productModel->loadByAttribute('sku', $sku);
                    //$refreshBrcodesString = $refreshProduct->getBarcode();

                    //$refreshBarcodes = explode(",", $refreshBrcodesString);
                    //$refreshBarcodes = array_map('trim', $refreshBarcodes);
                    //$refreshBarcodes = array_fill_keys( array_values($refreshBarcodes), false);
                   // foreach ($barcodes as $kk => $vv) $refreshBarcodes[$kk] = false;
					//if($barcodesString)
					$this->logConsole(++$t);
					$dddd = '';
					$this->logConsole(++$t);
					if (strpos($barcodesString, ',') === false){
						$this->logConsole(++$t);
						try{
							$this->logConsole(++$t);
							$this->logConsole(count($this->itemData));
							//if(isset($this->itemData[$sku]) && $this->itemData[$sku]['ID'] == 'h1') 
							if(isset($this->itemData[$sku])) {
								$dddd = $this->itemData[$sku];
							
								if(isset($dddd)){
									$this->logConsole(++$t);
									$stk = $dddd['QUANTITY'];
									if($stk > 0)
									{
										$stt=1;
										$enbl = 1;
									}
									$this->logConsole(++$t);
									$productRepository = $objectManager->create('Magento\Catalog\Api\ProductRepositoryInterface');
										  $stockRegistry = $objectManager->create('Magento\CatalogInventory\Api\StockRegistryInterface');
									$this->logConsole(++$t);
										  //Load product by SKU
										  $product1 = $productRepository->getById($product->getId());
									$this->logConsole(++$t);	  //Need to load stock item
										  $stockItem = $stockRegistry->getStockItem($product1->getId());
									$this->logConsole(++$t);	 // echo $stockItem->getData('qty');
										  //$stockItem->setData('qty',$stockItem->getData('qty') + $stockValue); //set updated quantity
											$product1->setQuantityAndStockStatus(['qty' => $stk, 'is_in_stock' => $stt]);
									$this->logConsole(++$t);	  //$product->setPrice($price);
										  $product1->setStatus($enbl);
									$this->logConsole(++$t);	 
									 $product1->save();
									$this->logConsole(++$t);
										  $stockRegistry->updateStockItemBySku($sku, $stockItem);
									$this->logConsole(++$t);
									/*$refreshProduct->setQuantityAndStockStatus(['qty' => $stk, 'is_in_stock' => $stt]);
									$refreshProduct->setStatus($enbl);
									$refreshProduct->save();*/
									$this->logConsole('Qty="'.$stk .'" Status="'.$enbl.'" and Stock Status="'.$stt .'" for SKU="' . $sku . '" updated');
									$this->logConsole('Stock Quantity and Stock Status Change Ends');
								}
							}
						}catch(Exception $ee){$this->logConsole('Skipping product with sku '.$sku);}
					}
					else{$this->logConsole('Skipping product with barcode have , and  with sku '.$sku);
					
						try{
							$ar = explode(',', $barcodesString);
							foreach ($ar as $arv) {
								$soap = new \SoapClient("http://58.27.236.238:901/services.asmx?wsdl", array('connection_timeout' => 5000));
								echo 'arv is -'.$arv.' ya';
								 $data = $soap->GetItemsByBarcode(array(
									'barcd' => $arv,
								));
					$stk = 0;
							$stt = 0;
							$enbl = 2;
								$data = json_decode($data->GetItemsByBarcodeResult);
					//            print_r($a);
								if (is_array($data) && count($data) > 0) {
									//echo $data['ID'];
									//print_r($data);
									echo 'SKU - '.$data[0]->PRODUCTID;
									$productRepository = $objectManager->create('Magento\Catalog\Api\ProductRepositoryInterface');
									  $stockRegistry = $objectManager->create('Magento\CatalogInventory\Api\StockRegistryInterface');
								
									  //Load product by SKU
									  $product = $productRepository->get($data[0]->PRODUCTID);
									  //Need to load stock item
									 echo $stk = $data[0]->QUANTITY;
									  if($stk > 0)
												{
													$stt=1;
													$enbl = 1;
												}
									  $stockItem = $stockRegistry->getStockItem($product->getId());
									 // echo $stockItem->getData('qty');
									  //$stockItem->setData('qty',$stockItem->getData('qty') + $stockValue); //set updated quantity
										$product->setQuantityAndStockStatus(['qty' => $stk, 'is_in_stock' => $stt, 'use_config_manage_stock' => 1, 'manage_stock' => 1]);
									  //$product->setPrice($price);
									  $product->setStatus($enbl);
									  $product->save();
								
									  $stockRegistry->updateStockItemBySku($data[0]->PRODUCTID, $stockItem);
									
									
									/*$refreshProduct = $productModel->load($value->getId());
									$refreshProduct->setQuantityAndStockStatus(['qty' => $stk, 'is_in_stock' => $stt]);
									$refreshProduct->setStatus($enbl);
									$refreshProduct->save();*/
									echo '-end'.$data[0]->PRODUCTID;
								}
							}
						//$data = $soap->GetAllItems(array('rnFrom' => 1,'rnTo' => 20000));
			//echo "<pre>";print_r($data);echo "</pre>";
						// echo $data->GetAllItemsResult;
						
			
						//foreach ($itemData as $k => $v) $this->itemData[$v['ID']] = $v;
						
			
						//$this->logConsole("Service Call Done");
					 //echo "<pre>"; print_r($orders->getItems()); echo "</pre>";
						}catch(Exception $eee){echo '-- hell--'.$eee->getMessage();}
					
					}
//                    $this->logConsole('combined barcodes: ' . implode( ',', array_keys($barcodes) ));
//                    die('stop');
                    //$refreshProduct->addAttributeUpdate('price', $maxRetailPrice, 0);
					//$refreshProduct->addAttributeUpdate('price', $maxRetailPrice, 0);
					//$product->setQuantityAndStockStatus(['qty' => $quantity, 'is_in_stock' => 1]);
                    //if (!empty($maxCostPrice)) $product->addAttributeUpdate('cost', $maxCostPrice, 0);
                    //$refreshProduct->addAttributeUpdate('barcode', implode( ',', array_keys($barcodes) ), 0);
					
					//$productRepository = $objectManager->create('Magento\Catalog\Api\ProductRepositoryInterface');
					  //$stockRegistry = $objectManager->create('Magento\CatalogInventory\Api\StockRegistryInterface');
				
					  //Load product by SKU
					  //$product = $productRepository->get($sku);
					  //Need to load stock item
					  //$stockItem = $stockRegistry->getStockItem($product->getId());
					 // echo $stockItem->getData('qty');
					  //$stockItem->setData('qty',$stockItem->getData('qty') + $stockValue); //set updated quantity
				//$product->setQuantityAndStockStatus(['qty' => 10, 'is_in_stock' => 1]);
					  //$product->setPrice($price);
					  //$product->save();
					
					
               /* }
                else
                {
                    $this->logConsole('Max retail price not found for SKU="' . $sku . '"', true, '0;31m');
                }*/


            } catch (Exception $e) {
                $this->logConsole($e->getMessage(), true, '0;31m');
            }
            $this->currentProduct++;
        }
    }

    private function logConsole($message, $newline = true, $color = '')
    {
        // RED - 0;31m
        if ($color) echo "\033[".$color;
        echo '[' . date('H:i:s') . '] (' . $this->currentProduct . '/' . $this->countProducts . ') ' . $message;
        if ($color) echo "\033[0m";
        if ($newline) echo "\n";

        if ($this->soapAllItemsErrors > 2)
        {
            echo "\033[0;31m Seems, that Service is unavaliable. Stop execution.\033[0m" . "\n";
            die();
        }

        if ($this->soapGetBarcodeDataErrors > 20)
        {
            echo "\033[0;31m Seems, that Service is unavaliable. Stop execution.\033[0m" . "\n";
            die();
        }

    }

    /**
     *
     * {@inheritdoc}
     */
    protected function configure()
    {
        $this->setName("vit_stockupdate:stockupdate");
        $this->setDescription("Update Stock Number and Stock Status ");
        $this->setDefinition([
//            new InputArgument(self::NAME_ARGUMENT, InputArgument::OPTIONAL, "Name"),
            new InputOption(self::NAME_OPTION, "o", InputOption::VALUE_NONE, "Update Stock Number and Stock Status only activated products")
        ]);
        parent::configure();
    }

    private function getAllDataBarcd($barcd)
    {

        try {
//            echo "\nFetching Data from Bar Code Service\n";
            //$client = new \SoapClient("http://43.245.131.42:901/services.asmx?wsdl");
            if (is_null($this->soap)) $this->soap = new \SoapClient("http://58.27.236.238:901/services.asmx?wsdl", array('connection_timeout' => 5000));

            $data = $this->soap->GetItemsByBarcode(array(
                'barcd' => $barcd,
            ));

            $data = $this->_json_decode($data->GetItemsByBarcodeResult);
//            print_r($a);
            if (is_array($data)) {
                return $data;
            }

            return false;

        } catch (\SoapFault $fault) {
            $this->soapGetBarcodeDataErrors++;
            $this->logConsole( 'Service error: ' . $fault->getMessage(), true, '0;31m' );
            return null;
        }

    }

    private function getAllData()
    {
        try {
            $this->logConsole("Fetching All Items Data from Service");
            ini_set('default_socket_timeout', 5000);

//     $client = new \SoapClient("http://58.27.236.238:901/services.asmx?wsdl");
            if (is_null($this->soap)) $this->soap = new \SoapClient("http://58.27.236.238:901/services.asmx?wsdl", array('connection_timeout' => 5000));

            $data = $this->soap->GetAllItems(array(
                'rnFrom' => 1,
                'rnTo' => 20000
            ));
//echo "<pre>";print_r($data);echo "</pre>";
            // echo $data->GetAllItemsResult;
            $itemData = $this->_json_decode($data->GetAllItemsResult);
//file_put_contents('ritesh.txt', print_r($itemData, true));
            foreach ($itemData as $k => $v) $this->itemData[$v['ID']] = $v;

            $this->logConsole("Service Call Done");
        } catch (\SoapFault $fault) {
            $this->soapAllItemsErrors++;
            $this->logConsole('Soap error: ' . $fault->getMessage(), true, '0;31m');
//            echo "error";
//            echo "http://58.27.236.238:901/services.asmx";
            return null;
        }

    }

    private function getProductData($sku)
    {
        if (empty($this->itemData)) {
            $this->getAllData();
        }
//echo "<pre>";print_r($this->itemData);echo "</pre>";
        $item = isset($this->itemData[$sku]) ? $this->itemData[$sku] : false;

        return $item;
    }

    private function _json_decode($string)
    {
        if (get_magic_quotes_gpc()) {
            $string = stripslashes($string);
        }

        return json_decode($string, true);
    }

    public function __construct(\Magento\Framework\App\State $state, \Psr\Log\LoggerInterface $logger)
    {
        //$state->setAreaCode('adminhtml'); // or 'adminhtml', depending on your needs
		$this->logger = $logger;
        parent::__construct();
    }
}

