<?php
namespace Vnecoms\FeaturedProduct\Controller\Adminhtml\Index;

use Vnecoms\FeaturedProduct\Controller\Adminhtml\AbstractAction;

class Delete extends AbstractAction
{
    /**
     * Is access to section allowed
     *
     * @return bool
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Vnecoms_FeaturedProduct::block') && parent::_isAllowed();
    }
    
    /**
     * @return void
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        $model = $this->_objectManager->create('Vnecoms\FeaturedProduct\Model\Block');

        if ($id) {
            $model->load($id);
            if (!$model->getBlockId()) {
                $this->messageManager->addError(__('This block no longer exists.'));
            }
            
            try {
                $model->delete();
                $this->messageManager->addSuccess(__("Your block has been deleted."));
            } catch (\Exception $e) {
                $this->messageManager->addError($e->getMessage());
            }
        } else {
            $this->messageManager->addError(__("The block id is invalid."));
        }
        
        $this->_redirect('featuredproduct/index');
    }
}
