<?php
namespace Vnecoms\FeaturedProduct\Model\Source;

class Direction extends \Magento\Eav\Model\Entity\Attribute\Source\AbstractSource
{
    const DIR_ASC = 'asc';
    const DIR_DESC = 'desc';
    /**
     * Options array
     *
     * @var array
     */
    protected $_options = null;
    
    /**
     * Retrieve all options array
     *
     * @return array
     */
    public function getAllOptions()
    {
        if ($this->_options === null) {
            $this->_options = [
                ['label' => __("Ascending"), 'value' => self::DIR_ASC],
                ['label' => __("Descending"), 'value' => self::DIR_DESC],
            ];
        }
        return $this->_options;
    }

    /**
     * Retrieve option array
     *
     * @return array
     */
    public function getOptionArray()
    {
        $_options = [];
        foreach ($this->getAllOptions() as $option) {
            $_options[$option['value']] = $option['label'];
        }
        return $_options;
    }
    
    
    /**
     * Get options as array
     *
     * @return array
     * @codeCoverageIgnore
     */
    public function toOptionArray()
    {
        return $this->getAllOptions();
    }
}
