<?php
namespace Vnecoms\FeaturedProduct\Model\Source;

class Period extends \Magento\Eav\Model\Entity\Attribute\Source\AbstractSource
{
    const PERIOD_DAY    = 'daily';
    const PERIOD_MONTH  = 'monthly';
    const PERIOD_YEAR   = 'yearly';
    
    /**
     * Options array
     *
     * @var array
     */
    protected $_options = null;
    
    /**
     * Retrieve all options array
     *
     * @return array
     */
    public function getAllOptions()
    {
        if ($this->_options === null) {
            $this->_options = [
                ['label' => __("Today"), 'value' => self::PERIOD_DAY],
                ['label' => __("This Month"), 'value' => self::PERIOD_MONTH],
                ['label' => __("This Year"), 'value' => self::PERIOD_YEAR],
            ];
        }
        return $this->_options;
    }

    /**
     * Retrieve option array
     *
     * @return array
     */
    public function getOptionArray()
    {
        $_options = [];
        foreach ($this->getAllOptions() as $option) {
            $_options[$option['value']] = $option['label'];
        }
        return $_options;
    }
    
    
    /**
     * Get options as array
     *
     * @return array
     * @codeCoverageIgnore
     */
    public function toOptionArray()
    {
        return $this->getAllOptions();
    }
}
