<?php
namespace Vnecoms\FeaturedProduct\Model\Source;

class SortBy extends \Magento\Eav\Model\Entity\Attribute\Source\AbstractSource
{
    const SORT_RANDOM           = 'random';
    const SORT_ATTRIBUTE        = 'attribute';
    const SORT_BESTSELLER       = 'best_seller';
    const SORT_TOP_RATED        = 'top_rated';
    const SORT_MOST_REVIEWS     = 'most_reviews';
    const SORT_MOST_VIEWED      = 'most_viewed';
    const SORT_CREATED_DATE     = 'created_date';
    
    /**
     * Options array
     *
     * @var array
     */
    protected $_options = null;
    
    /**
     * Retrieve all options array
     *
     * @return array
     */
    public function getAllOptions()
    {
        if ($this->_options === null) {
            $this->_options = [
                ['label' => __("Random"), 'value' => self::SORT_RANDOM],
                ['label' => __("Product Attribute"), 'value' => self::SORT_ATTRIBUTE],
                ['label' => __("Top Selling"), 'value' => self::SORT_BESTSELLER],
                ['label' => __("Most Reviews"), 'value' => self::SORT_MOST_REVIEWS],
                ['label' => __("Top Rated"), 'value' => self::SORT_TOP_RATED],
                ['label' => __("Most Viewed"), 'value' => self::SORT_MOST_VIEWED],
                ['label' => __("Created Date"), 'value' => self::SORT_CREATED_DATE],
            ];
        }
        return $this->_options;
    }

    /**
     * Retrieve option array
     *
     * @return array
     */
    public function getOptionArray()
    {
        $_options = [];
        foreach ($this->getAllOptions() as $option) {
            $_options[$option['value']] = $option['label'];
        }
        return $_options;
    }
    
    
    /**
     * Get options as array
     *
     * @return array
     * @codeCoverageIgnore
     */
    public function toOptionArray()
    {
        return $this->getAllOptions();
    }
}
