<?php
namespace Vnecoms\FeaturedProduct\Model\Source;

class Template extends \Magento\Eav\Model\Entity\Attribute\Source\AbstractSource
{
    const TEMPLATE_GRID = 'grid';
    const TEMPLATE_LIST = 'list';
    const TEMPLATE_SLIDER = 'slider';
    /**
     * Options array
     *
     * @var array
     */
    protected $_options = null;
    
    /**
     * Retrieve all options array
     *
     * @return array
     */
    public function getAllOptions()
    {
        if ($this->_options === null) {
            $this->_options = [
                ['label' => __("Grid"), 'value' => self::TEMPLATE_GRID],
                ['label' => __("List"), 'value' => self::TEMPLATE_LIST],
                ['label' => __("Slider"), 'value' => self::TEMPLATE_SLIDER],
            ];
        }
        return $this->_options;
    }

    /**
     * Retrieve option array
     *
     * @return array
     */
    public function getOptionArray()
    {
        $_options = [];
        foreach ($this->getAllOptions() as $option) {
            $_options[$option['value']] = $option['label'];
        }
        return $_options;
    }
    
    
    /**
     * Get options as array
     *
     * @return array
     * @codeCoverageIgnore
     */
    public function toOptionArray()
    {
        return $this->getAllOptions();
    }
}
