<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\AccountVerify;

    class CheckAccount extends AbstractAccount    {

        public function execute()   {
            $returnArray                 = [];
            $returnArray["success"]      = false;
            $returnArray["resultstatus"] = '';
            try {
                $wholeData      = $this->getRequest()->getPostValue();
                $this->_headers = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey  = $this->getRequest()->getHeader("authKey");
                    $authData = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $storeId     = $wholeData["storeId"]    ?? 1;
                        $mobileNo    = $wholeData["mobileNumber"] ?? '';
                        $email       = $wholeData["email"] ?? '';
                        $countryCode = $wholeData["co"] ?? '';
                        $customerId = $wholeData["customerId"] ?? '';
                        $environment = $this->_emulate->startEnvironmentEmulation($storeId);

                        if ($customerId && $mobileNo == '') {
                            $checkMobileNumber = $this->_verProcess->getMobileNumberIfNotExist($email);
                            $mobileNo = $checkMobileNumber[0]['mobile_number'] ?? '';
                        }
                        $data = [
                            'email'         => $email,
                            'countrycode'   => $countryCode,
                            'mobile_number' => $mobileNo
                        ];
                        $response = $this->_verProcess->validateAccount($data);

                        if (count($response) == 1) {
                            if ($response[0]['ver_status'] == 'Confirmed'){
                                $returnArray["resultstatus"] = 'confirmed';
                            } else {
                                $returnArray["resultstatus"] = 'waiting';
                            }
                        } else {
                            $returnArray["resultstatus"] = 'notverified';
                        }
                        $returnArray["success"] = true;
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch (\Exception $e) {
                $returnArray["message"] = $e->getMessage();
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }