<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Adminhtml;
    use Magento\Backend\App\Action\Context;
    use Magento\Ui\Component\MassAction\Filter;
    use Magento\Framework\App\Filesystem\DirectoryList;
    use Magento\Backend\Model\View\Result\ForwardFactory;
    use Webkul\Mobikul\Api\Data\FeaturedcategoriesInterfaceFactory;
    use Webkul\Mobikul\Model\ResourceModel\Featuredcategories\CollectionFactory;

    abstract class Featuredcategories extends \Magento\Backend\App\Action   {

        protected $_date;
        protected $_filter;
        protected $_jsonHelper;
        protected $_storeManager;
        protected $_mediaDirectory;
        protected $_resultPageFactory;
        protected $_collectionFactory;
        protected $_resultJsonFactory;
        protected $_categoryRepository;
        protected $_coreRegistry = null;
        protected $_fileUploaderFactory;
        protected $_resultForwardFactory;
        protected $_categoryResourceModel;
        protected $_featuredcategoriesRepository;
        protected $_featuredcategoriesDataFactory;

        public function __construct(
            Filter $filter,
            Context $context,
            ForwardFactory $resultForwardFactory,
            CollectionFactory $collectionFactory,
            \Magento\Framework\Registry $coreRegistry,
            \Magento\Framework\Filesystem $filesystem,
            \Magento\Framework\Json\Helper\Data $jsonHelper,
            \Magento\Framework\Stdlib\DateTime\DateTime $date,
            \Magento\Store\Model\StoreManagerInterface $storeManager,
            \Magento\Framework\View\Result\PageFactory $resultPageFactory,
            FeaturedcategoriesInterfaceFactory $featuredcategoriesDataFactory,
            \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
            \Magento\Catalog\Model\ResourceModel\Category $categoryResourceModel,
            \Magento\Catalog\Api\CategoryRepositoryInterface $categoryRepository,
            \Magento\MediaStorage\Model\File\UploaderFactory $fileUploaderFactory,
            \Webkul\Mobikul\Api\FeaturedcategoriesRepositoryInterface $featuredcategoriesRepository
        ) {
            parent::__construct($context);
            $this->_date                          = $date;
            $this->_filter                        = $filter;
            $this->_jsonHelper                    = $jsonHelper;
            $this->_storeManager                  = $storeManager;
            $this->_coreRegistry                  = $coreRegistry;
            $this->_mediaDirectory                = $filesystem->getDirectoryWrite(DirectoryList::MEDIA);
            $this->_collectionFactory             = $collectionFactory;
            $this->_resultJsonFactory             = $resultJsonFactory;
            $this->_resultPageFactory             = $resultPageFactory;
            $this->_categoryRepository            = $categoryRepository;
            $this->_fileUploaderFactory           = $fileUploaderFactory;
            $this->_resultForwardFactory          = $resultForwardFactory;
            $this->_categoryResourceModel         = $categoryResourceModel;
            $this->_featuredcategoriesRepository  = $featuredcategoriesRepository;
            $this->_featuredcategoriesDataFactory = $featuredcategoriesDataFactory;
        }

        protected function _isAllowed()   {
            return $this->_authorization->isAllowed("Webkul_Mobikul::featuredcategories");
        }

    }