<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Adminhtml\Featuredcategories;

    class MassEnable extends \Webkul\Mobikul\Controller\Adminhtml\Featuredcategories    {

        public function execute()   {
            $collection                 = $this->_filter->getCollection($this->_collectionFactory->create());
            $coditionArr                = [];
            $resultRedirect             = $this->resultRedirectFactory->create();
            $featuredcategoriessUpdated = 0;
            foreach ($collection->getAllIds() as $key => $featuredcategoriesId) {
                $currentFeaturedcategories = $this->_featuredcategoriesRepository->getById($featuredcategoriesId);
                $featuredcategoriesData    = $currentFeaturedcategories->getData();
                if (count($featuredcategoriesData)) {
                    $condition = "`id`=".$featuredcategoriesId;
                    array_push($coditionArr, $condition);
                    $featuredcategoriessUpdated++;
                }
            }
            $coditionData = implode(" OR ", $coditionArr);
            $collection->setFeaturedcategoriesData($coditionData, ["status"=>1]);
            if ($featuredcategoriessUpdated)
                $this->messageManager->addSuccess(__("A total of %1 record(s) were enabled.", $featuredcategoriessUpdated));
            return $resultRedirect->setPath("mobikul/featuredcategories/index");
        }

        protected function _isAllowed()     {
            return $this->_authorization->isAllowed("Webkul_Mobikul::featuredcategories");
        }

    }