<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Catalog;
    use Magento\Store\Model\App\Emulation;
    use Magento\Framework\App\Action\Context;
    use Webkul\Mobikul\Helper\Data as HelperData;
    use Magento\Framework\Stdlib\DateTime\DateTime;
    use Magento\Catalog\Api\ProductRepositoryInterface;
    use Webkul\Mobikul\Helper\Catalog as HelperCatalog;

    abstract class AbstractCatalog extends \Webkul\Mobikul\Controller\ApiController    {

        protected $_dir;
        protected $_date;
        protected $_items;
        protected $_quote;
        protected $_store;
        protected $_helper;
        protected $_rating;
        protected $_review;
        protected $_emulate;
        protected $_escaper;
        protected $_toolbar;
        protected $_compare;
        protected $_baseDir;
        protected $_headers;
        protected $_customer;
        protected $_wishlist;
        protected $_category;
        protected $_taxHelper;
        protected $_eavConfig;
        protected $_sendFriend;
        protected $_localeDate;
        protected $_jsonHelper;
        protected $_connection;
        protected $_bannerImage;
        protected $_linkFactory;
        protected $_listProduct;
        protected $_imageHelper;
        protected $_coreRegistry;
        protected $_localeFormat;
        protected $_queryFactory;
        protected $_stockFilter;
        protected $_productPrice;
        protected $_mobikulLayer;
        protected $_categoryTree;
        protected $_eventManager;
        protected $_productLinks;
        protected $_categoryLayer;
        protected $_productOption;
        protected $_helperCatalog;
        protected $_pricingHelper;
        protected $_catalogConfig;
        protected $_cmsCollection;
        protected $_productStatus;
        protected $_customerImage;
        protected $_productSample;
        protected $_groupedProduct;
        protected $_checkoutHelper;
        protected $_layerAttribute;
        protected $_downloadSample;
        protected $_websiteManager;
        protected $_downloadHelper;
        protected $_storeInterface;
        protected $_productFactory;
        protected $_customerVisitor;
        protected $_bundlePriceModel;
        protected $_searchCollection;
        protected $_compareListBlock;
        protected $_configurableBlock;
        protected $_productCollection;
        protected $_productRepository;
        protected $_productVisibility;
        protected $_mobikulLayerPrice;
        protected $_productCountSelect;
        protected $_productOptionBlock;
        protected $_featuredCategories;
        protected $_compareItemFactory;
        protected $_catalogHelperOutput;
        protected $_filterableAttributes;
        protected $_categoryImageFactory;
        protected $_productResourceModel;
        protected $_advancedCatalogSearch;
        protected $_categoryResourceModel;
        protected $_filterPriceDataprovider;
        protected $_productResourceCollection;
        protected $_layerFilterAttributeResource;
        protected $_compareItemCollectionFactory;
        protected $_cmsPage;
        protected $_filterProvider;
        protected $categoryTree;

        public function __construct(
            DateTime $date,
            Context $context,
            Emulation $emulate,
            HelperData $helper,
            HelperCatalog $helperCatalog,
            \Magento\Store\Model\Store $store,
            \Magento\Quote\Model\Quote $quote,
            \Magento\Framework\Escaper $escaper,
            \Magento\Review\Model\Rating $rating,
            \Magento\Review\Model\Review $review,
            \Magento\Eav\Model\Config $eavConfig,
            \Magento\Catalog\Helper\Data $taxHelper,
            \Webkul\Mobikul\Model\Layer $mobikulLayer,
            \Magento\Framework\Registry $coreRegistry,
            \Magento\Customer\Model\Customer $customer,
            \Magento\Catalog\Helper\Image $imageHelper,
            \Magento\Catalog\Model\Config $catalogConfig,
            ProductRepositoryInterface $productRepository,
            \Magento\Checkout\Helper\Data $checkoutHelper,
            \Webkul\Mobikul\Model\Bannerimage $bannerImage,
            \Magento\Framework\Locale\Format $localeFormat,
            \Webkul\Mobikul\Model\UserImage $customerImage,
            \Magento\Framework\Json\Helper\Data $jsonHelper,
            \Magento\SendFriend\Model\SendFriend $sendFriend,
            \Magento\Catalog\Model\CategoryFactory $category,
            \Magento\Search\Model\QueryFactory $queryFactory,
            \Magento\Framework\Filesystem\DirectoryList $dir,
            \Magento\Customer\Model\Visitor $customerVisitor,
            \Magento\Catalog\Helper\Product\Compare $compare,
            \Magento\Wishlist\Model\WishlistFactory $wishlist,
            \Webkul\Mobikul\Model\Category\Tree $categoryTree,
            \Magento\Downloadable\Helper\File $downloadHelper,
            \Magento\Downloadable\Model\Sample $downloadSample,
            \Magento\Catalog\Block\Product\Price $productPrice,
            \Magento\Store\Model\WebsiteFactory $websiteManager,
            \Magento\CatalogInventory\Helper\Stock $stockFilter,
            \Magento\Catalog\Helper\Output $catalogHelperOutput,
            \Magento\Catalog\Model\Product\Option $productOption,
            \Magento\Downloadable\Model\LinkFactory $linkFactory,
            \Magento\Bundle\Model\Product\Price $bundlePriceModel,
            \Webkul\Mobikul\Block\Configurable $configurableBlock,
            \Magento\Framework\Pricing\Helper\Data $pricingHelper,
            \Magento\Catalog\Model\ProductFactory $productFactory,
            \Magento\Framework\App\ResourceConnection $connection,
            \Magento\Catalog\Block\Product\ListProduct $listProduct,
            \Magento\Framework\Event\ManagerInterface $eventManager,
            \Magento\Store\Model\StoreManagerInterface $storeInterface,
            \Magento\Catalog\Block\Product\ProductList\Toolbar $toolbar,
            \Magento\Catalog\Model\Layer\Filter\Category $categoryLayer,
            \Magento\Catalog\Model\Product\Visibility $productVisibility,
            \Webkul\Mobikul\Model\Featuredcategories $featuredCategories,
            \Magento\CatalogSearch\Model\Advanced $advancedCatalogSearch,
            \Magento\Cms\Model\ResourceModel\Page\Collection $cmsCollection,
            \Magento\Catalog\Block\Product\View\Options $productOptionBlock,
            \Magento\Downloadable\Block\Catalog\Product\Links $productLinks,
            \Magento\Framework\Stdlib\DateTime\TimezoneInterface $localeDate,
            \Webkul\Mobikul\Model\CategoryimagesFactory $categoryImageFactory,
            \Magento\Catalog\Model\ResourceModel\Product $productResourceModel,
            \Magento\Downloadable\Block\Catalog\Product\Samples $productSample,
            \Magento\GroupedProduct\Model\Product\Type\Grouped $groupedProduct,
            \Magento\Catalog\Block\Product\Compare\ListCompare $compareListBlock,
            \Magento\Catalog\Model\Layer\Filter\AttributeFactory $layerAttribute,
            \Magento\Catalog\Model\ResourceModel\Category $categoryResourceModel,
            \Magento\Catalog\Model\Product\Attribute\Source\Status $productStatus,
            \Magento\Catalog\Model\Product\Compare\ItemFactory $compareItemFactory,
            \Webkul\Mobikul\Model\ResourceModel\Layer\Filter\Price $mobikulLayerPrice,
            \Magento\CatalogSearch\Model\ResourceModel\Search\Collection $searchCollection,
            \Magento\Catalog\Model\ResourceModel\Product\CollectionFactory $productCollection,
            \Magento\Catalog\Model\ResourceModel\Product\Collection $productResourceCollection,
            \Magento\Catalog\Model\Layer\Category\FilterableAttributeList $filterableAttributes,
            \Magento\Catalog\Model\Layer\Filter\DataProvider\PriceFactory $filterPriceDataprovider,
            \Magento\Catalog\Model\ResourceModel\Layer\Filter\AttributeFactory $layerFilterAttributeResource,
            \Magento\Catalog\Model\ResourceModel\Product\Compare\Item\CollectionFactory $compareItemCollectionFactory,
            \Magento\Cms\Model\Page $cmsPage,
            \Magento\Cms\Model\Template\FilterProvider $filterProvider,
            \Magento\Catalog\Model\Category\TreeFactory $categoryTreeFactory,
            \Magento\Catalog\Model\ResourceModel\Category\TreeFactory $categoryResourceTreeFactory,
            \Magento\Catalog\Model\ResourceModel\Category\CollectionFactory $categoryCollectionFactory
        ) {
            $this->_date                         = $date;
            $this->_store                        = $store;
            $this->_quote                        = $quote;
            $this->_helper                       = $helper;
            $this->_rating                       = $rating;
            $this->_review                       = $review;
            $this->_escaper                      = $escaper;
            $this->_compare                      = $compare;
            $this->_baseDir                      = $dir->getPath("media");
            $this->_toolbar                      = $toolbar;
            $this->_emulate                      = $emulate;
            $this->_category                     = $category;
            $this->_wishlist                     = $wishlist;
            $this->_customer                     = $customer;
            $this->_taxHelper                    = $taxHelper;
            $this->_eavConfig                    = $eavConfig;
            $this->_connection                   = $connection;
            $this->_sendFriend                   = $sendFriend;
            $this->_localeDate                   = $localeDate;
            $this->_jsonHelper                   = $jsonHelper;
            $this->_linkFactory                  = $linkFactory;
            $this->_listProduct                  = $listProduct;
            $this->_bannerImage                  = $bannerImage;
            $this->_stockFilter                  = $stockFilter;
            $this->_imageHelper                  = $imageHelper;
            $this->_eventManager                 = $eventManager;
            $this->_categoryTree                 = $categoryTree;
            $this->_localeFormat                 = $localeFormat;
            $this->_queryFactory                 = $queryFactory;
            $this->_mobikulLayer                 = $mobikulLayer;
            $this->_coreRegistry                 = $coreRegistry;
            $this->_productLinks                 = $productLinks;
            $this->_productPrice                 = $productPrice;
            $this->_productSample                = $productSample;
            $this->_helperCatalog                = $helperCatalog;
            $this->_customerImage                = $customerImage;
            $this->_productStatus                = $productStatus;
            $this->_categoryLayer                = $categoryLayer;
            $this->_pricingHelper                = $pricingHelper;
            $this->_catalogConfig                = $catalogConfig;
            $this->_cmsCollection                = $cmsCollection;
            $this->_productOption                = $productOption;
            $this->_groupedProduct               = $groupedProduct;
            $this->_downloadHelper               = $downloadHelper;
            $this->_layerAttribute               = $layerAttribute;
            $this->_downloadSample               = $downloadSample;
            $this->_storeInterface               = $storeInterface;
            $this->_websiteManager               = $websiteManager;
            $this->_checkoutHelper               = $checkoutHelper;
            $this->_productFactory               = $productFactory;
            $this->_customerVisitor              = $customerVisitor;
            $this->_bundlePriceModel             = $bundlePriceModel;
            $this->_compareListBlock             = $compareListBlock;
            $this->_searchCollection             = $searchCollection;
            $this->_configurableBlock            = $configurableBlock;
            $this->_mobikulLayerPrice            = $mobikulLayerPrice;
            $this->_productRepository            = $productRepository;
            $this->_productVisibility            = $productVisibility;
            $this->_productCollection            = $productCollection;
            $this->_featuredCategories           = $featuredCategories;
            $this->_compareItemFactory           = $compareItemFactory;
            $this->_productOptionBlock           = $productOptionBlock;
            $this->_catalogHelperOutput          = $catalogHelperOutput;
            $this->_categoryImageFactory         = $categoryImageFactory;
            $this->_filterableAttributes         = $filterableAttributes;
            $this->_productResourceModel         = $productResourceModel;
            $this->_advancedCatalogSearch        = $advancedCatalogSearch;
            $this->_categoryResourceModel        = $categoryResourceModel;
            $this->_filterPriceDataprovider      = $filterPriceDataprovider;
            $this->_productResourceCollection    = $productResourceCollection;
            $this->_layerFilterAttributeResource = $layerFilterAttributeResource;
            $this->_compareItemCollectionFactory = $compareItemCollectionFactory;
            $this->_cmsPage                      = $cmsPage;
            $this->_filterProvider               = $filterProvider;
            $this->categoryTree = $categoryTreeFactory->create(
                [
                    'categoryTree' => $categoryResourceTreeFactory->create(),
                    'categoryCollection' => $categoryCollectionFactory->create()
                ]
            );
            parent::__construct($helper, $context);
        }

    }