<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Catalog;

    class AdvancedSearchFormData extends AbstractCatalog  {

        public function execute()   {
            $returnArray                 = [];
            $returnArray["success"]      = false;
            $returnArray["message"]      = "";
            $returnArray["fieldList"]    = [];
            try {
                $wholeData       = $this->getRequest()->getPostValue();
                $this->_headers  = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey  = $this->getRequest()->getHeader("authKey");
                    $authData = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $storeId     = $wholeData["storeId"] ?? 0;
                        $environment = $this->_emulate->startEnvironmentEmulation($storeId);
                        $attributes  = $this->_advancedCatalogSearch->getAttributes();
                        foreach($attributes as $attribute)  {
                            $each                   = [];
                            $label                  = $attribute->getStoreLabel();
                            $each["label"]          = $label;
                            $each["title"]          = $this->_helperCatalog->stripTags($label);
                            $each["options"]        = $attribute->getSource()->getAllOptions(false);
                            $each["inputType"]      = $this->_helperCatalog->getAttributeInputType($attribute);
                            $each["attributeCode"]  = $attribute->getAttributeCode();
                            $each["maxQueryLength"] = $this->_helperCatalog->getMaxQueryLength();
                            $returnArray["fieldList"][] = $each;
                        }
                        $this->_emulate->stopEnvironmentEmulation($environment);
                        $returnArray["success"] = true;
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch (\Exception $e) {
                $returnArray["message"] = __($e->getMessage());
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }