<?php
    /**
    * Webkul Software.
    *
    * @category Webkul
    *
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Download;

    class DownloadLinkSample extends \Webkul\Mobikul\Controller\ApiController   {

        protected $_downloadableLink;
        protected $_downloadableHelperFile;
        protected $_downloadableHelperDownload;

        public function __construct(
            \Webkul\Mobikul\Helper\Data $helper,
            \Magento\Store\Model\App\Emulation $emulate,
            \Webkul\Mobikul\Helper\Catalog $helperCatalog,
            \Magento\Framework\App\Action\Context $context,
            \Magento\Downloadable\Model\Link $downloadableLink,
            \Magento\Downloadable\Helper\File $downloadableHelperFile,
            \Magento\Downloadable\Helper\Download $downloadableHelperDownload
        ) {
            $this->_downloadableLink           = $downloadableLink;
            $this->_downloadableHelperFile     = $downloadableHelperFile;
            $this->_downloadableHelperDownload = $downloadableHelperDownload;
            parent::__construct($helper, $context);
        }

        public function execute()   {
            $linkId             = $this->getRequest()->getParam("linkId");
            $link               = $this->_downloadableLink->load($linkId);
            $sampleLinkFilePath = $this->_downloadableHelperFile->getFilePath($this->_downloadableLink->getBaseSamplePath(), $link->getSampleFile());
            $sampleLinkFilePath = $this->_helperCatalog->getBasePath()."/".$sampleLinkFilePath;
            $resourceType       = \Magento\Downloadable\Helper\Download::LINK_TYPE_FILE;
            $helper             = $this->_downloadableHelperDownload;
            $helper->setResource($sampleLinkFilePath, $resourceType);
            $fileName           = $helper->getFilename();
            $contentType        = $helper->getContentType();
            $this->getResponse()->setHttpResponseCode(200)
                ->setHeader("Pragma", "public", true)
                ->setHeader("Cache-Control", "must-revalidate, post-check=0, pre-check=0", true)
                ->setHeader("Content-type", $contentType, true);
            if ($fileSize = $helper->getFileSize())
                $this->getResponse()->setHeader("Content-Length", $fileSize);
            if ($contentDisposition = $helper->getContentDisposition())
                $this->getResponse()->setHeader("Content-Disposition", $contentDisposition . "; filename=" . $fileName);
            $this->getResponse()->clearBody();
            $this->getResponse()->sendHeaders();
            $helper->output();
            exit(0);
        }

    }