<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Adminhtml\Featuredcategories;
    use Magento\Framework\Controller\ResultFactory;

    class MassDelete extends \Webkul\Mobikul\Controller\Adminhtml\Featuredcategories        {

        public function execute()       {
            $collection                 = $this->_filter->getCollection($this->_collectionFactory->create());
            $resultRedirect             = $this->resultRedirectFactory->create();
            $featuredcategoriessDeleted = 0;
            foreach ($collection->getAllIds() as $featuredcategoriesId) {
                if (!empty($featuredcategoriesId)) {
                    try {
                        $this->_featuredcategoriesRepository->deleteById($featuredcategoriesId);
                        $featuredcategoriessDeleted++;
                    } catch (\Exception $exception) {
                        $this->messageManager->addError($exception->getMessage());
                    }
                }
            }
            if ($featuredcategoriessDeleted)
                $this->messageManager->addSuccess(__("A total of %1 Featuredcategory(ies) were deleted.", $featuredcategoriessDeleted));
            $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
            return $resultRedirect->setPath("mobikul/featuredcategories/index");
        }

        protected function _isAllowed() {
            return $this->_authorization->isAllowed("Webkul_Mobikul::featuredcategories");
        }

    }