<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Checkout;

    class ChangeOrderStatus extends AbstractCheckout    {

        public function execute()   {
            $returnArray                 = [];
            $returnArray["message"]      = "";
            $returnArray["success"]      = false;
            try {
                $wholeData       = $this->getRequest()->getPostValue();
                $this->_headers  = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey     = $this->getRequest()->getHeader("authKey");
                    $authData    = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $status      = $wholeData["status"]      ?? 0;
                        $confirm     = $wholeData["confirm"]     ?? "{}";
                        $storeId     = $wholeData["storeId"]     ?? 1;
                        $customerId  = $wholeData["customerId"]  ?? 0;
                        $incrementId = $wholeData["incrementId"] ?? "";
                        $confirm     = $this->_jsonHelper->jsonDecode($confirm);
                        $environment = $this->_emulate->startEnvironmentEmulation($storeId);
                        $order       = $this->_orderFactory->create()->loadByIncrementId($incrementId);
                        $payment     = $order->getPayment();
                        $payment->setTransactionId($confirm["response"]["id"])
                            ->setPreparedMessage("status : ".$confirm["response"]["state"])
                            ->setShouldCloseParentTransaction(true)
                            ->setIsTransactionClosed(0)
                            ->registerCaptureNotification($order->getGrandTotal());
                        $order->save();
                        $state = "";
                        if ($status == 0) {
                            $order->setState(\Magento\Sales\Model\Order::STATE_PROCESSING)
                                ->setStatus(\Magento\Sales\Model\Order::STATE_PROCESSING)
                                ->save();
                            $state = \Magento\Sales\Model\Order::STATE_PROCESSING;
                        } else {
                            $order->setState(\Magento\Sales\Model\Order::STATE_CANCELED)
                                ->setStatus(\Magento\Sales\Model\Order::STATE_CANCELED)
                                ->save();
                            $state = \Magento\Sales\Model\Order::STATE_CANCELED;
                        }
                        if ($order->canInvoice()) {
                            $invoice = $this->_invoiceService->prepareInvoice($order);
                            $invoice->setRequestedCaptureCase(\Magento\Sales\Model\Order\Invoice::CAPTURE_ONLINE);
                            $invoice->register();
                            $transactionSave = $this->_dbTransaction->addObject($invoice)->addObject($invoice->getOrder());
                            $transactionSave->save();
                            $this->_invoiceSender->send($invoice);
                        }
                        $comment = "status :".$confirm["response"]["state"]."<br>";
                        $comment .= "transaction id :".$confirm["response"]["id"]."<br>";
                        $comment .= "date :".$confirm["response"]["create_time"]."<br>";
                        $comment .= "from :".$confirm["client"]["product_name"]."<br>";
                        $order->addStatusHistoryComment($comment)->setIsCustomerNotified(true);
                        $order->save();
                        $returnArray["success"] = true;
                        $this->_emulate->stopEnvironmentEmulation($environment);
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch(Exception $e)   {
                $returnArray["message"] = $e->getMessage();
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }