<?php
    /**
    * Webkul Software.
    *
    * @category  Webkul
    * @package   Webkul_Mobikul
    * @author    Webkul
    * @copyright Copyright (c) 2010-2018 Webkul Software Private Limited (https://webkul.com)
    * @license   https://store.webkul.com/license.html
    */

    namespace Webkul\Mobikul\Controller\Extra;

    class Logout extends AbstractMobikul    {

        public function execute()   {
            $returnArray                 = [];
            $returnArray["message"]      = "";
            try {
                $wholeData       = $this->getRequest()->getPostValue();
                $this->_headers  = $this->getRequest()->getHeaders();
                $this->_helper->log(__CLASS__, "logClass", $wholeData);
                $this->_helper->log($wholeData, "logParams", $wholeData);
                $this->_helper->log($this->_headers, "logHeaders", $wholeData);
                if ($wholeData) {
                    $authKey     = $this->getRequest()->getHeader("authKey");
                    $authData    = $this->_helper->isAuthorized($authKey);
                    if ($authData["code"] == 1) {
                        $token       = $wholeData["token"]      ?? "";
                        $storeId     = $wholeData["storeId"]    ?? 1;
                        $customerId  = $wholeData["customerId"] ?? 0;
                        $collection  = $this->_deviceTokenFactory
                            ->create()
                            ->getCollection()
                            ->addFieldToFilter("customer_id", $customerId)
                            ->addFieldToFilter("token", $token);
                        foreach($collection as $eachToken)
                            $this->_deviceTokenFactory->create()->load($eachToken->getId())->setCustomerId(0)->save();
                        $this->_customerSession->unsetAll();
                        // $this->_coreSession->unsetAll();
                        $this->_objectManager->create("Magento\Checkout\Model\Session")->clearQuote();
// merging compare list /////////////////////////////////////////////////////////////////////////////////////////////////////////
                        $this->_productCompare->setAllowUsedFlat(false);
                        $items = $this->_compareCollection->create();
                        $items->useProductItem(true)->setStoreId($storeId);
                        $items->setVisitorId($this->_visitor->getId());
                        $attributes = $this->_catalogConfig->getProductAttributes();
                        $items->addAttributeToSelect($attributes)
                            ->loadComparableAttributes()
                            ->addMinimalPrice()
                            ->addTaxPercents()
                            ->setVisibility($this->_productVisibility->getVisibleInSiteIds());
                        foreach ($items as $item) {
                            $this->_compareItem->purgeVisitorByCustomer($item);
                            $this->_productCompare->calculate(true);
                        }
                        $this->_helper->log($returnArray, "logResponse", $wholeData);
                        return $this->getJsonResponse($returnArray);
                    } else {
                        return $this->getJsonResponse($returnArray, 401, $authData["token"]);
                    }
                } else {
                    $returnArray["message"]      = __("Invalid Request");
                    $this->_helper->log($returnArray, "logResponse", $wholeData);
                    return $this->getJsonResponse($returnArray);
                }
            } catch (\Exception $e) {
                $returnArray["message"] = $e->getMessage();
                $this->_helper->printLog($returnArray, 1);
                return $this->getJsonResponse($returnArray);
            }
        }

    }