<?php
/**
 * Copyright © 2017 Mageside. All rights reserved.
 * See MS-LICENSE.txt for license details.
 */

namespace Mageside\BackupToDropbox\Model\Lib;

class DropboxApp extends \Kunnu\Dropbox\DropboxApp
{
    /**
     * @var \Mageside\BackupToDropbox\Helper\Backup
     */
    protected $_configHelper;

    /**
     * DropboxApp constructor.
     * @param \Mageside\BackupToDropbox\Helper\Backup $configHelper
     */
    public function __construct(
        \Mageside\BackupToDropbox\Helper\Backup $configHelper
    ) {
        $this->_configHelper = $configHelper;

        $clientId = $this->_configHelper->getConfigModule('XML_PATH_BACKUP_CLIENT_ID');
        $clientSecret = $this->_configHelper->getConfigModule('XML_PATH_BACKUP_CLIENT_SECRET');
        $accessToken = $this->_configHelper->getConfigModule('XML_PATH_BACKUP_ACCESS_TOKEN');
        $accessToken = $accessToken ?: null;
        parent::__construct($clientId, $clientSecret, $accessToken);
    }
}
