<?php
/**
 * Copyright © 2017 Mageside. All rights reserved.
 * See MS-LICENSE.txt for license details.
 */

namespace Mageside\BackupToDropbox\Plugin\Db;

class BackupDb
{
    /**
     * @var \Mageside\BackupToDropbox\Helper\Backup
     */
    protected $_magesideHelper;

    /**
     * BackupDb constructor.
     * @param \Mageside\BackupToDropbox\Helper\Backup $magesideHelper
     */
    public function __construct(
        \Mageside\BackupToDropbox\Helper\Backup $magesideHelper
    ) {
        $this->_magesideHelper = $magesideHelper;
    }

    /**
     * @param \Magento\Framework\Backup\Db\BackupFactory $subject
     * @param $result
     * @return mixed
     */
    public function afterCreateBackupDbModel(\Magento\Framework\Backup\Db\BackupFactory $subject, $result)
    {
        if (is_array($this->_magesideHelper->getIgnoreTableList())
            && $this->_magesideHelper->getIgnoreTableList()
            && !empty($this->_magesideHelper->getIgnoreTableList())) {
            $tableArray = $this->_magesideHelper->getIgnoreTableList();
            $result->addIgnoreDataTablesList($tableArray);
        }
        return $result;
    }
}
