/**
 * Copyright © 2017 Codazon. All rights reserved.
 * See COPYING.txt for license details.
 */
define([
    "jquery",
    "matchMedia",
    "jquery/ui",
    'Codazon_AjaxLayeredNav/js/layout'
    ], function ($, mediaCheck) {
    'use strict';
    function setParam(data, name, value){
        var tmp = '';
        var flag = false;
        var result = '';
        if(data){
            tmp = data.split('&');
        }
        if(tmp.length > 0){
            for(var i = 0; i < tmp.length; i++){
                var tmp2 = tmp[i].split('=');
                if(tmp2.length > 1 && tmp2[0] == name)
                {
                    tmp2[1] = value;
                    flag = true;
                }
                if(tmp2.length > 1){
                    result += ('&' + tmp2[0] + '=' + tmp2[1]);
                }
            }
        }
        if(!flag){
            result += ('&' + name + '=' + value);
        }
        return result;
    }
    $.widget('codazon.ajaxlayer', {
		options: {
			url: "",
			jsonFilter: "",
			catparam: "",
			uriRequest: "",
			uriShow: "",
			baseUrl: "",
            responsive: true,
            expanded: false,
            delay: 300,
        },

        _create: function () {
            var self = this;
            //this._super();
        },

        _init: function () {
            //this._super();
            this.delay = this.options.delay;

            if (this.options.expanded === true) {
                //this.isExpanded();
            }

            var href = window.location.href;
	        var params = href.split('#');
	        var param = catparam;
            $('.toolbar-products').removeAttr('data-mage-init');
	        if(params[1]){
	            param += this.convertCodeToId(params[1]);
	            this.request(param);
	        }else{
	            this.uriRequest = param;
	            this.initClickAjax();
	            this.initChangeOrderByAjax();
	            this.initSortOrderAjax();
	            this.initLimiterAjax();
                this.initAjaxModeSwitcher();
	        }
        },
        displayOverlay: function(text) {
            $("<div id='overlay'><div class='rectangle-bounce'><div class='rect1'></div><div class='rect2'></div><div class='rect3'></div><div class='rect4'></div><div class='rect5'></div></div></div>").css({
                "position": "fixed",
                "top": "0px",
                "left": "0px",
                "width": "100%",
                "height": "100%",
                "background-color": "rgba(0,0,0,.5)",
                "z-index": "10000",
                "vertical-align": "middle",
                "text-align": "center",
                "color": "#fff",
                "font-size": "40px",
                "font-weight": "bold",
                "cursor": "wait"
            }).appendTo("body");
        },

        removeOverlay: function() {
            $("#overlay").remove();
        },        
        setParam: function(data, name, value){
            var tmp = '';
            var flag = false;
            var result = '';
            if(data){
                tmp = data.split('&');
            }
            if(tmp.length > 0){
                for(var i = 0; i < tmp.length; i++){
                    var tmp2 = tmp[i].split('=');
                    if(tmp2.length > 1 && tmp2[0] == name)
                    {
                        tmp2[1] = value;
                        flag = true;
                    }
                    if(tmp2.length > 1){
                        result += ('&' + tmp2[0] + '=' + tmp2[1]);
                    }
                }
            }
            if(!flag){
                result += ('&' + name + '=' + value);
            }
            return result;
        },
        
        convertIdToCode: function(data)
        {
            var tmp = '';
            var result = '';
            if(data){
                tmp = data.split('&');
            }
            if(tmp.length > 0){
                for(var i = 0; i < tmp.length; i++){
                    var attr = tmp[i].split('=');
                    if(attr.length > 1)
                    {
                        var code = attr[0];
                        var value = attr[1];
                        if(jsonFilter.hasOwnProperty(code) && code != 'price'){
                            value = jsonFilter[code][value];
                        }
                        result += ('&' + code + '=' + value);
                    }
                }
            }
            return result;
        },
        
        convertCodeToId: function(data)
        {
            var tmp = '';
            var result = '';
            if(data){
                tmp = data.split('&');
            }
            if(tmp.length > 0){
                for(var i = 0; i < tmp.length; i++){
                    var attr = tmp[i].split('=');
                    if(attr.length > 1)
                    {
                        var code = attr[0];
                        var value = attr[1];
                        if(jsonFilter.hasOwnProperty(code) && code != 'price'){
                            //value = jsonFilter[code][value];
                            for(var i in jsonFilter[code]){
                                if(jsonFilter[code][i] == value){
                                    value = i;
                                    break;
                                }
                            }
                        }
                        result += ('&' + code + '=' + value);
                    }
                }
            }
            return result;
        },
        
        initSortOrderAjax: function(){
            var self = this;
            $('[data-role="direction-switcher"]').removeAttr('data-role').click(function(e){
                e.preventDefault();
                if($(this).hasClass('sort-asc')){
                    var href = self.uriRequest;
                    var param = href +'&product_list_dir=desc';
                    self.request(param);
                    var tmp = param.replace(catparam,'');
                    tmp = tmp.replace('undefined','');
                    window.location.href = '#'+tmp;
                    return false;
                }else if($(this).hasClass('sort-desc')){
                    var href = self.uriRequest;
                    var param = href.replace('&product_list_dir=desc','');
                    self.request(param);
                    var tmp = param.replace(catparam,'');
                    tmp = tmp.replace('undefined','');
                    self.uriShow = self.convertIdToCode(tmp);
                    window.location.href = '#'+self.uriShow;
                    return false;
                }
            });
        },
        
        initChangeOrderByAjax: function(){
            var self = this;
            $('[data-role="sorter"]').removeAttr('data-role').on('change', function(e) {
                e.preventDefault();
                var href = self.uriRequest;
                var param = setParam(href,'product_list_order',$(this).val());;
                self.request(param);
                var tmp = param.replace(catparam,'');
                tmp = tmp.replace('undefined','');
                self.uriShow = self.convertIdToCode(tmp);
                window.location.href = '#'+self.uriShow;
                return false;
            });
        },
        
        initLimiterAjax: function(){
            var self = this;
            $('[data-role="limiter"]').removeAttr('data-role').on('change', function() {
                var href = self.uriRequest;
                var param = setParam(href,'product_list_limit',$(this).val());;
                self.request(param);
                var tmp = param.replace(catparam,'');
                tmp = tmp.replace('undefined','');
                self.uriShow = self.convertIdToCode(tmp);
                window.location.href = '#'+self.uriShow;
                return false;
            });
        },
        
        initClickAjax: function(){
            var obj = this;
            $('#layered-filter-block a').each(function(){
                $(this).click(function(){
                    var href = $(this).attr('href');
                    var params = href.split('?');
                    var param = catparam + "&" + params[1];
                    obj.request(param);
                    var tmp = params[1].replace(catparam,'');
                    tmp = tmp.replace('undefined','');
                    obj.uriShow = obj.convertIdToCode(tmp);
                    window.location.href = '#'+obj.uriShow;
                    return false;
                });
            });
            $('.pages a').each(function(){
                $(this).click(function(){
                    var href = $(this).attr('href');
                    var params = href.split('?');
                    var param = catparam + "&" + params[1];
                    obj.request(param);
                    var tmp = params[1].replace(catparam,'');
                    tmp = tmp.replace('undefined','');
                    obj.uriShow = obj.convertIdToCode(tmp);
                    window.location.href = '#'+obj.uriShow;
                    return false;
                });
            });
        },
        initQuickshop: function(){
            var configs = {
    		    "baseUrl": baseUrl,
    		    "qsLabel": "Quick Shop",
    		    "itemClass": ".product-item",
    		    "target": ".product-item-info",
    		    "autoAddButtons":true			
    		};
            requirejs(['Codazon_QuickShop/js/quickshop'],function(quickshop){
                quickshop(configs,$('body'));
            }); 
        },
        
        initAddToCart: function(){
            var configs = {
    		    "baseUrl": baseUrl,
    		    "qsLabel": "Quick Shop",
    		    "itemClass": ".product-item",
    		    "target": ".product-item-info",
    		    "autoAddButtons":true			
    		};
            requirejs(['catalogAddToCart'],function(catalogAddToCart){
                catalogAddToCart({},$('[data-role=tocart-form], .form.map.checkout'));
            }); 
        },
        initAjaxModeSwitcher: function(){
            $('[data-role="mode-switcher"]').removeAttr('data-role');
            $.codazon.categoryLayout({},$('body'));
        },
        request: function(param){
            var obj = this;
            this.displayOverlay('Loading...');
            this.uriRequest = param;
            $.ajax({
                url: url+'?'+param,
                cache:true
            }).done(function(json) {
                var data = jQuery.parseJSON(json);
                if ($('body').hasClass('page-layout-1column')) {
                    $('.column.main:first').html(data.layer + data.products);
                } else {
                    $('#toolbar-wrap').remove();
                    $('.columns .main:first').html(data.products);
                    $('#layered-filter-block').replaceWith(data.layer);
                }
                obj.initClickAjax();
                obj.initChangeOrderByAjax();
                obj.initSortOrderAjax();
                obj.initLimiterAjax();
                obj.initAjaxModeSwitcher();
                obj.removeOverlay();
                
                $('#layered-filter-block').trigger('contentUpdated',null);
                
            });
        }
    });
    return $.codazon.ajaxlayer;
});